#  Copyright (C) 1999-2007
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc AnalysisMenu {} {
    global ds9

    # WARNING: this is a variable length menu. 
    # Be sure to update ds9(menu,size,analysis)
    menu $ds9(mb).analysis
    $ds9(mb).analysis add command -label "[msgcat::mc {Pixel Table}]..." \
	-command PTDialog 
    $ds9(mb).analysis add separator
#    $ds9(mb).analysis add checkbutton -label [msgcat::mc {Show Mask}] 
#	-variable mask(view) -command MaskUpdate
#    $ds9(mb).analysis add cascade -label [msgcat::mc {Mask Color}] 
#	-menu $ds9(mb).analysis.mask
#    $ds9(mb).analysis add separator
    $ds9(mb).analysis add checkbutton -label [msgcat::mc {Contours}] \
	-variable contour(view) -command ContourUpdate
    $ds9(mb).analysis add command \
	-label "[msgcat::mc {Contour Parameters}]..."\
	-command ContourDialog
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add checkbutton -label [msgcat::mc {Coordinate Grid}] \
	-variable grid(view) -command GridUpdate
    $ds9(mb).analysis add command \
	-label "[msgcat::mc {Coordinate Grid Parameters}]..." \
	-command GridDialog
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add checkbutton -label [msgcat::mc {Smooth}] \
	-variable smooth(view) -command SmoothUpdate
    $ds9(mb).analysis add command \
	-label "[msgcat::mc {Smooth Parameters}]..." \
	-command SmoothDialog
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add command \
	-label "[msgcat::mc {Name Resolution}]..." \
	-command NRESDialog
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add cascade -label [msgcat::mc {Image Servers}] \
	-menu $ds9(mb).analysis.image
    $ds9(mb).analysis add cascade -label [msgcat::mc {Archives}] \
	-menu $ds9(mb).analysis.arch
    $ds9(mb).analysis add cascade -label [msgcat::mc {Catalogs}] \
	-menu $ds9(mb).analysis.cat
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add command \
	-label "[msgcat::mc {Virtual Observatory}]..."\
	-command "VODialog 0"
    $ds9(mb).analysis add command -label "[msgcat::mc {Plot Tool}]..." \
	-command AnalysisPlotTool
    $ds9(mb).analysis add command -label "[msgcat::mc {Web Browser}]..." \
	-command {HV web Web {} 2 1 {}}
    $ds9(mb).analysis add command -label "[msgcat::mc {Catalog Tool}]..." \
	-command {CATOther none}
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add checkbutton \
	-label [msgcat::mc {Analysis Command Log}] \
	-variable analysis(log)
    $ds9(mb).analysis add separator
    $ds9(mb).analysis add command \
	-label "[msgcat::mc {Load Analysis Commands}]..." \
	-command LoadAnalysisDialog
    $ds9(mb).analysis add command \
	-label [msgcat::mc {Clear Analysis Commands}] \
	-command ClearAnalysisDialog

    menu $ds9(mb).analysis.mask
    $ds9(mb).analysis.mask add radiobutton -label [msgcat::mc {Black}] \
	-variable mask(color) -value black -command MaskColor
    $ds9(mb).analysis.mask add radiobutton -label [msgcat::mc {White}] \
	-variable mask(color) -value white -command MaskColor
    $ds9(mb).analysis.mask add radiobutton -label [msgcat::mc {Red}] \
	-variable mask(color) -value red -command MaskColor
    $ds9(mb).analysis.mask add radiobutton -label [msgcat::mc {Green}] \
	-variable mask(color) -value green -command MaskColor
    $ds9(mb).analysis.mask add radiobutton -label [msgcat::mc {Blue}] \
	-variable mask(color) -value blue -command MaskColor
    $ds9(mb).analysis.mask add radiobutton -label [msgcat::mc {Cyan}] \
	-variable mask(color) -value cyan -command MaskColor
    $ds9(mb).analysis.mask add radiobutton -label [msgcat::mc {Magenta}] \
	-variable mask(color) -value magenta -command MaskColor
    $ds9(mb).analysis.mask add radiobutton -label [msgcat::mc {Yellow}] \
	-variable mask(color) -value yellow -command MaskColor

    menu $ds9(mb).analysis.image
    $ds9(mb).analysis.image add command \
	-label {Digital Sky Survey (DSS-SAO)} -command DSSSAODialog
    $ds9(mb).analysis.image add command \
	-label {Digital Sky Survey (DSS-ESO)} -command DSSESODialog
    $ds9(mb).analysis.image add command \
	-label {Digital Sky Survey (DSS-STSCI)} -command DSSSTSCIDialog
    $ds9(mb).analysis.image add command \
	-label {Two Micron All Sky Survey (2MASS)} -command 2MASSDialog
    $ds9(mb).analysis.image add command \
	-label {VLA FIRST Survey (VLA)} -command FIRSTDialog

    menu $ds9(mb).analysis.cat
    $ds9(mb).analysis.cat add command -label [msgcat::mc {Clear All}] \
	-command CATClearFrame
    $ds9(mb).analysis.cat add separator
    CATCatalogMenu {}

    # Analysis Archive Menu
    # WARNING: this is a variable length menu. 
    # Be sure to update ds9(menu,size,arch)
    menu $ds9(mb).analysis.arch
    $ds9(mb).analysis.arch add command -label {NVO DataScope} \
	-command HVArchDataScope
    $ds9(mb).analysis.arch add separator
    $ds9(mb).analysis.arch add cascade -label {Chandra} \
	-menu $ds9(mb).analysis.arch.chandra
    $ds9(mb).analysis.arch add command -label {ROSAT All-Sky (MPE/MPG)} \
	-command HVArchRosat
    $ds9(mb).analysis.arch add command -label {SkyView (NASA/HEASARC)} \
	-command HVArchSkyView
    $ds9(mb).analysis.arch add command -label {W3Browse (NASA/HEASARC)} \
	-command HVArchW3Browse
    $ds9(mb).analysis.arch add separator
    $ds9(mb).analysis.arch add command -label {NVSS (NRAO)} \
	-command HVArchNVSS
    $ds9(mb).analysis.arch add command -label {4MASS (NRAO)} \
	-command HVArch4MASS
    $ds9(mb).analysis.arch add command -label {SIRTF FLS/VLA (NRAO)} \
	-command HVArchSIRTF
    $ds9(mb).analysis.arch add command -label {VLA First (NRAO)} \
	-command HVArchFirst
    $ds9(mb).analysis.arch add separator
    $ds9(mb).analysis.arch add command -label {NED (NASA/IPAC)} \
	-command HVArchNED
    $ds9(mb).analysis.arch add cascade -label {SIMBAD (CDS)} \
	-menu $ds9(mb).analysis.arch.simbad
    $ds9(mb).analysis.arch add cascade -label {ADS (SAO)} \
	-menu $ds9(mb).analysis.arch.ads
    $ds9(mb).analysis.arch add separator
    $ds9(mb).analysis.arch add command -label {SAO TDC (SAO)} \
	-command HVArchSAOTDC
    $ds9(mb).analysis.arch add separator

    HVArchUserMenu

    menu $ds9(mb).analysis.arch.chandra
    $ds9(mb).analysis.arch.chandra add command \
	-label {Chaser (NASA/SAO)} -command HVArchChandraChaser
    $ds9(mb).analysis.arch.chandra add command \
	-label {Fast Image (NASA/SAO)} -command HVArchChandraPop
    $ds9(mb).analysis.arch.chandra add command \
	-label {Public FTP (SAO)} -command HVArchChandraFTP

    menu $ds9(mb).analysis.arch.simbad
    $ds9(mb).analysis.arch.simbad add command -label {SAO} \
	-command HVArchSIMBADSAO
    $ds9(mb).analysis.arch.simbad add command -label {CDS} \
	-command HVArchSIMBADCDS

    menu $ds9(mb).analysis.arch.ads
    $ds9(mb).analysis.arch.ads add command -label {SAO} \
	-command HVArchADSSAO
    $ds9(mb).analysis.arch.ads add command -label {CDS} \
	-command HVArchADSCDS

    AnalysisPrefsMenu
}

proc AnalysisPrefsMenu {} {
    global ds9
    global prefs
    
    # Analysis Prefs
    menu $ds9(mb).prefs.gui.analysis
#    $ds9(mb).prefs.gui.analysis add checkbutton 
#	-label [msgcat::mc {Show Mask}] 
#	-variable prefs(mask,view) -command SavePrefs
#    $ds9(mb).prefs.gui.analysis add cascade -label [msgcat::mc {Mask Color}] 
#	-menu $ds9(mb).prefs.gui.analysis.mask
#    $ds9(mb).prefs.gui.analysis add separator
    $ds9(mb).prefs.gui.analysis add cascade -label [msgcat::mc {Contours}] \
	-menu $ds9(mb).prefs.gui.analysis.contour
    $ds9(mb).prefs.gui.analysis add separator
    $ds9(mb).prefs.gui.analysis add cascade -label [msgcat::mc {Smooth}] \
	-menu $ds9(mb).prefs.gui.analysis.smooth
    $ds9(mb).prefs.gui.analysis add separator
    $ds9(mb).prefs.gui.analysis add cascade -label [msgcat::mc {Name Server}] \
	-menu $ds9(mb).prefs.gui.analysis.namesvr
    $ds9(mb).prefs.gui.analysis add cascade -label [msgcat::mc {DSS Server}] \
	-menu $ds9(mb).prefs.gui.analysis.dsssvr
    $ds9(mb).prefs.gui.analysis add cascade -label [msgcat::mc {Catalogs}] \
	-menu $ds9(mb).prefs.gui.analysis.cat
    $ds9(mb).prefs.gui.analysis add separator
    $ds9(mb).prefs.gui.analysis add cascade \
	-label [msgcat::mc {Archive Server}] \
	-menu $ds9(mb).prefs.gui.analysis.archive
    $ds9(mb).prefs.gui.analysis add separator
    $ds9(mb).prefs.gui.analysis add cascade \
	-label [msgcat::mc {Virtual Observatory}] \
	-menu $ds9(mb).prefs.gui.analysis.vo
    $ds9(mb).prefs.gui.analysis add separator
    $ds9(mb).prefs.gui.analysis add checkbutton \
	-label [msgcat::mc {Analysis Command Log}] \
	-variable prefs(analysis,log) -command SavePrefs
    $ds9(mb).prefs.gui.analysis add separator
    $ds9(mb).prefs.gui.analysis add cascade \
	-label [msgcat::mc {Preload Analysis File}] \
	-menu $ds9(mb).prefs.gui.analysis.preload
    $ds9(mb).prefs.gui.analysis add cascade \
	-label [msgcat::mc {Analysis Plot}] \
	-menu $ds9(mb).prefs.gui.analysis.plot

    # Mask Prefs
    menu $ds9(mb).prefs.gui.analysis.mask
    $ds9(mb).prefs.gui.analysis.mask add radiobutton \
	-label [msgcat::mc {Black}] -variable prefs(mask,color) -value black \
	-command SavePrefs
    $ds9(mb).prefs.gui.analysis.mask add radiobutton \
	-label [msgcat::mc {White}] -variable prefs(mask,color) -value white \
	-command SavePrefs
    $ds9(mb).prefs.gui.analysis.mask add radiobutton \
	-label [msgcat::mc {Red}] -variable prefs(mask,color) -value red \
	-command SavePrefs
    $ds9(mb).prefs.gui.analysis.mask add radiobutton \
	-label [msgcat::mc {Green}] -variable prefs(mask,color) -value green \
	-command SavePrefs
    $ds9(mb).prefs.gui.analysis.mask add radiobutton \
	-label [msgcat::mc {Blue}] -variable prefs(mask,color) -value blue \
	-command SavePrefs
    $ds9(mb).prefs.gui.analysis.mask add radiobutton \
	-label [msgcat::mc {Cyan}] -variable prefs(mask,color) -value cyan \
	-command SavePrefs
    $ds9(mb).prefs.gui.analysis.mask add radiobutton \
	-label [msgcat::mc {Magenta}] -variable prefs(mask,color) \
	-value magenta -command SavePrefs
    $ds9(mb).prefs.gui.analysis.mask add radiobutton \
	-label [msgcat::mc {Yellow}] -variable prefs(mask,color) -value yellow \
	-command SavePrefs

    # Analysis Contour Prefs
    menu $ds9(mb).prefs.gui.analysis.contour
    $ds9(mb).prefs.gui.analysis.contour add cascade \
	-label [msgcat::mc {Color}] \
	-menu $ds9(mb).prefs.gui.analysis.contour.color
    $ds9(mb).prefs.gui.analysis.contour add cascade \
	-label [msgcat::mc {Width}] \
	-menu $ds9(mb).prefs.gui.analysis.contour.width
    $ds9(mb).prefs.gui.analysis.contour add cascade \
	-label [msgcat::mc {Method}] \
	-menu $ds9(mb).prefs.gui.analysis.contour.method

    # Analysis Contour Color Prefs
    menu $ds9(mb).prefs.gui.analysis.contour.color
    $ds9(mb).prefs.gui.analysis.contour.color add radiobutton \
	-label [msgcat::mc {Black}] \
	-variable prefs(contour,color) -value black -command SavePrefs
    $ds9(mb).prefs.gui.analysis.contour.color add radiobutton \
	-label [msgcat::mc {White}] \
	-variable prefs(contour,color) -value white  -command SavePrefs
    $ds9(mb).prefs.gui.analysis.contour.color add radiobutton \
	-label [msgcat::mc {Red}] \
	-variable prefs(contour,color) -value red  -command SavePrefs
    $ds9(mb).prefs.gui.analysis.contour.color add radiobutton \
	-label [msgcat::mc {Green}] \
	-variable prefs(contour,color) -value green  -command SavePrefs
    $ds9(mb).prefs.gui.analysis.contour.color add radiobutton \
	-label [msgcat::mc {Blue}] \
	-variable prefs(contour,color) -value blue  -command SavePrefs
    $ds9(mb).prefs.gui.analysis.contour.color add radiobutton \
	-label [msgcat::mc {Cyan}] \
	-variable prefs(contour,color) -value cyan  -command SavePrefs
    $ds9(mb).prefs.gui.analysis.contour.color add radiobutton \
	-label [msgcat::mc {Magenta}] \
	-variable prefs(contour,color) -value magenta  -command SavePrefs
    $ds9(mb).prefs.gui.analysis.contour.color add radiobutton \
	-label [msgcat::mc {Yellow}] \
	-variable prefs(contour,color) -value yellow  -command SavePrefs

    # Analysis Contour Width Prefs
    menu $ds9(mb).prefs.gui.analysis.contour.width
    $ds9(mb).prefs.gui.analysis.contour.width add radiobutton -label {1} \
	-variable prefs(contour,width) -value 1 -command SavePrefs
    $ds9(mb).prefs.gui.analysis.contour.width add radiobutton -label {2} \
	-variable prefs(contour,width) -value 2 -command SavePrefs
    $ds9(mb).prefs.gui.analysis.contour.width add radiobutton -label {3} \
	-variable prefs(contour,width) -value 3 -command SavePrefs
    $ds9(mb).prefs.gui.analysis.contour.width add radiobutton -label {4} \
	-variable prefs(contour,width) -value 4 -command SavePrefs

    # Analysis Contour Method Prefs
    menu $ds9(mb).prefs.gui.analysis.contour.method
    $ds9(mb).prefs.gui.analysis.contour.method add radiobutton \
	-label [msgcat::mc {Block}] \
	-variable prefs(contour,method) -value block -command SavePrefs
    $ds9(mb).prefs.gui.analysis.contour.method add radiobutton \
	-label [msgcat::mc {Smooth}] \
	-variable prefs(contour,method) -value smooth -command SavePrefs

    # Analysis Smooth Prefs
    menu $ds9(mb).prefs.gui.analysis.smooth
    $ds9(mb).prefs.gui.analysis.smooth add cascade \
	-label [msgcat::mc {Function}] \
	-menu $ds9(mb).prefs.gui.analysis.smooth.function

    # Analysis Smooth Function Prefs
    menu $ds9(mb).prefs.gui.analysis.smooth.function
    $ds9(mb).prefs.gui.analysis.smooth.function add radiobutton \
	-label [msgcat::mc {Boxcar}] \
	-variable prefs(smooth,function) -value boxcar -command SavePrefs
    $ds9(mb).prefs.gui.analysis.smooth.function add radiobutton \
	-label [msgcat::mc {Tophat}] \
	-variable prefs(smooth,function) -value tophat -command SavePrefs
    $ds9(mb).prefs.gui.analysis.smooth.function add radiobutton \
	-label [msgcat::mc {Gaussian}] \
	-variable prefs(smooth,function) -value gaussian -command SavePrefs

    # Analysis Name Server Prefs
    menu $ds9(mb).prefs.gui.analysis.namesvr
    $ds9(mb).prefs.gui.analysis.namesvr add radiobutton -label {NED@SAO} \
	-variable nres(server) -value ned-sao -command SavePrefs
    $ds9(mb).prefs.gui.analysis.namesvr add radiobutton -label {NED@ESO} \
	-variable nres(server) -value ned-eso -command SavePrefs
    $ds9(mb).prefs.gui.analysis.namesvr add radiobutton -label {SIMBAD@SAO} \
	-variable nres(server) -value simbad-sao -command SavePrefs
    $ds9(mb).prefs.gui.analysis.namesvr add radiobutton -label {SIMBAD@ESO} \
	-variable nres(server) -value simbad-eso -command SavePrefs

    # Analysis Catalog Prefs
    menu $ds9(mb).prefs.gui.analysis.cat
    $ds9(mb).prefs.gui.analysis.cat add cascade -label [msgcat::mc {Server}] \
	-menu $ds9(mb).prefs.gui.analysis.cat.server
    $ds9(mb).prefs.gui.analysis.cat add cascade -label [msgcat::mc {Symbol}] \
	-menu $ds9(mb).prefs.gui.analysis.cat.sym

    # Analysis Catalog Server Prefs
    menu $ds9(mb).prefs.gui.analysis.cat.server
    $ds9(mb).prefs.gui.analysis.cat.server add radiobutton -label {CDS} \
	-variable cat(server) -value cds -command SavePrefs
    $ds9(mb).prefs.gui.analysis.cat.server add radiobutton -label {SAO} \
	-variable cat(server) -value sao -command SavePrefs
    $ds9(mb).prefs.gui.analysis.cat.server add radiobutton -label {CADC} \
	-variable cat(server) -value cadc -command SavePrefs
    $ds9(mb).prefs.gui.analysis.cat.server add radiobutton -label {ADAC} \
	-variable cat(server) -value adac -command SavePrefs
    $ds9(mb).prefs.gui.analysis.cat.server add radiobutton -label {IUCAA} \
	-variable cat(server) -value iucaa -command SavePrefs
    $ds9(mb).prefs.gui.analysis.cat.server add radiobutton -label {BEJING} \
	-variable cat(server) -value bejing -command SavePrefs
    $ds9(mb).prefs.gui.analysis.cat.server add radiobutton \
	-label {CAMBRIDGE UK} \
	-variable cat(server) -value cambridge -command SavePrefs
    $ds9(mb).prefs.gui.analysis.cat.server add radiobutton \
	-label {UKIRT HAWAII} \
	-variable cat(server) -value ukirt -command SavePrefs

    # Analysis Catalog Symbol Prefs
    menu $ds9(mb).prefs.gui.analysis.cat.sym
    $ds9(mb).prefs.gui.analysis.cat.sym add radiobutton \
	-label [msgcat::mc {Circle Point}] \
	-variable cat(sym,shape) -value {circle point} -command SavePrefs
    $ds9(mb).prefs.gui.analysis.cat.sym add radiobutton \
	-label [msgcat::mc {Box Point}] \
	-variable cat(sym,shape) -value {box point} -command SavePrefs
    $ds9(mb).prefs.gui.analysis.cat.sym add radiobutton \
	-label [msgcat::mc {Diamond Point}] \
	-variable cat(sym,shape) -value {diamond point} -command SavePrefs
    $ds9(mb).prefs.gui.analysis.cat.sym add radiobutton \
	-label [msgcat::mc {Cross Point}] \
	-variable cat(sym,shape) -value {cross point} -command SavePrefs
    $ds9(mb).prefs.gui.analysis.cat.sym add radiobutton \
	-label [msgcat::mc {X Point}] \
	-variable cat(sym,shape) -value {x point} -command SavePrefs
    $ds9(mb).prefs.gui.analysis.cat.sym add radiobutton \
	-label [msgcat::mc {Arrow Point}] \
	-variable cat(sym,shape) -value {arrow point} -command SavePrefs
    $ds9(mb).prefs.gui.analysis.cat.sym add radiobutton \
	-label [msgcat::mc {BoxCircle Point}] \
	-variable cat(sym,shape) -value {boxcircle point} -command SavePrefs
    $ds9(mb).prefs.gui.analysis.cat.sym add separator
    $ds9(mb).prefs.gui.analysis.cat.sym add radiobutton \
	-label [msgcat::mc {Circle}] \
	-variable cat(sym,shape) -value circle -command SavePrefs
    $ds9(mb).prefs.gui.analysis.cat.sym add radiobutton \
	-label [msgcat::mc {Ellipse}] \
	-variable cat(sym,shape) -value ellipse -command SavePrefs
    $ds9(mb).prefs.gui.analysis.cat.sym add radiobutton \
	-label [msgcat::mc {Box}] \
	-variable cat(sym,shape) -value box -command SavePrefs
    $ds9(mb).prefs.gui.analysis.cat.sym add radiobutton \
	-label [msgcat::mc {Text}] \
	-variable cat(sym,shape) -value text -command SavePrefs
    $ds9(mb).prefs.gui.analysis.cat.sym add separator
    $ds9(mb).prefs.gui.analysis.cat.sym add radiobutton \
	-label [msgcat::mc {White}] \
	-variable cat(sym,color) -value white -command SavePrefs
    $ds9(mb).prefs.gui.analysis.cat.sym add radiobutton \
	-label [msgcat::mc {Black}] \
	-variable cat(sym,color) -value black -command SavePrefs
    $ds9(mb).prefs.gui.analysis.cat.sym add radiobutton \
	-label [msgcat::mc {Red}] \
	-variable cat(sym,color) -value red -command SavePrefs
    $ds9(mb).prefs.gui.analysis.cat.sym add radiobutton \
	-label [msgcat::mc {Green}] \
	-variable cat(sym,color) -value green -command SavePrefs
    $ds9(mb).prefs.gui.analysis.cat.sym add radiobutton \
	-label [msgcat::mc {Blue}] \
	-variable cat(sym,color) -value blue -command SavePrefs
    $ds9(mb).prefs.gui.analysis.cat.sym add radiobutton \
	-label [msgcat::mc {Cyan}] \
	-variable cat(sym,color) -value cyan -command SavePrefs
    $ds9(mb).prefs.gui.analysis.cat.sym add radiobutton \
	-label [msgcat::mc {Magenta}] \
	-variable cat(sym,color) -value magenta -command SavePrefs
    $ds9(mb).prefs.gui.analysis.cat.sym add radiobutton \
	-label [msgcat::mc {Yellow}] \
	-variable cat(sym,color) -value yellow -command SavePrefs

    # Analysis Archive Prefs
    menu $ds9(mb).prefs.gui.analysis.archive
    $ds9(mb).prefs.gui.analysis.archive add command -label {1} \
	-command {PrefsHVArch 1}
    $ds9(mb).prefs.gui.analysis.archive add command -label {2} \
	-command {PrefsHVArch 2}
    $ds9(mb).prefs.gui.analysis.archive add command -label {3} \
	-command {PrefsHVArch 3}
    $ds9(mb).prefs.gui.analysis.archive add command -label {4} \
	-command {PrefsHVArch 4}

    # Analysis VO Prefs
    menu $ds9(mb).prefs.gui.analysis.vo
    $ds9(mb).prefs.gui.analysis.vo add checkbutton \
	-label [msgcat::mc {Use Internal Web Browser}] \
	-variable vo(hv) -command SavePrefs
    $ds9(mb).prefs.gui.analysis.vo add separator
    $ds9(mb).prefs.gui.analysis.vo add radiobutton \
	-label [msgcat::mc {Connect Use Web Proxy}] \
	-variable vo(method) -value mime -command PrefsVOMethod
    $ds9(mb).prefs.gui.analysis.vo add radiobutton \
	-label [msgcat::mc {Connect Directly}] \
	-variable vo(method) -value xpa -command PrefsVOMethod
    $ds9(mb).prefs.gui.analysis.vo add separator
    $ds9(mb).prefs.gui.analysis.vo add command \
	-label "[msgcat::mc {Select VO Server}]..." \
	-command PrefsVOServer

    # Analysis Preload Prefs
    menu $ds9(mb).prefs.gui.analysis.preload
    $ds9(mb).prefs.gui.analysis.preload add command -label {1} \
	-command {PrefsAnalysisUser ds9(analysis,user)}
    $ds9(mb).prefs.gui.analysis.preload add command -label {2} \
	-command {PrefsAnalysisUser ds9(analysis,user2)}
    $ds9(mb).prefs.gui.analysis.preload add command -label {3} \
	-command {PrefsAnalysisUser ds9(analysis,user3)}
    $ds9(mb).prefs.gui.analysis.preload add command -label {4} \
	-command {PrefsAnalysisUser ds9(analysis,user4)}

    # Analysis Plot Prefs
    PrefsAPMenu
}

proc UpdateAnalysisMenu {} {
    global ds9
    global current
    global analysis

    global debug
    if {$debug(tcl,update)} {
	puts "UpdateAnalysisMenu"
    }

    if {$current(frame) != {}} {
	$ds9(mb) entryconfig [msgcat::mc {Analysis}] -state normal
	for {set i 0} {$i<$analysis(menu,count)} {incr i} {

	    if {[$current(frame) has fits]} {
		set fn [$current(frame) get fits file name 1]
	    } else {
		set fn {none}
	    }

	    # disable by default
	    $analysis(menu,$i,parent) entryconfig $analysis(menu,$i,item) \
		-state disabled

	    foreach t $analysis(menu,$i,template) {
		if {[regexp ".$t" $fn]} {
		    $analysis(menu,$i,parent) entryconfig \
			$analysis(menu,$i,item) -state normal
		    break
		}
	    }
	}
    } else {
	$ds9(mb) entryconfig [msgcat::mc {Analysis}] -state disabled
    }
}

