#  Copyright (C) 1999-2007
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc BinMenu {} {
    global ds9

    menu $ds9(mb).bin
    $ds9(mb).bin add radiobutton -label [msgcat::mc {Average}] \
	-variable bin(function) -value average -command ChangeBinFunction
    $ds9(mb).bin add radiobutton -label [msgcat::mc {Sum}] \
	-variable bin(function) -value sum -command ChangeBinFunction
    $ds9(mb).bin add separator
    $ds9(mb).bin add command -label [msgcat::mc {Block In}] \
	-command {Bin .5 .5}
    $ds9(mb).bin add command -label [msgcat::mc {Block Out}] \
	-command {Bin 2 2}
    $ds9(mb).bin add separator
    $ds9(mb).bin add command -label [msgcat::mc {Block to Fit Frame}] \
	-command BinToFit
    $ds9(mb).bin add separator
    $ds9(mb).bin add radiobutton -label "[msgcat::mc {Block}] 1" \
	-variable bin(factor) -value { 1 1 } -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label "[msgcat::mc {Block}] 2" \
	-variable bin(factor) -value { 2 2 } -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label "[msgcat::mc {Block}] 4" \
	-variable bin(factor) -value { 4 4 } -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label "[msgcat::mc {Block}] 8" \
	-variable bin(factor) -value { 8 8 } -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label "[msgcat::mc {Block}] 16" \
	-variable bin(factor) -value { 16 16 } -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label "[msgcat::mc {Block}] 32" \
	-variable bin(factor) -value { 32 32 } -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label "[msgcat::mc {Block}] 64" \
	-variable bin(factor) -value { 64 64 } -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label "[msgcat::mc {Block}] 128" \
	-variable bin(factor) -value { 128 128 } -command ChangeBinFactor
    $ds9(mb).bin add radiobutton -label "[msgcat::mc {Block}] 256" \
	-variable bin(factor) -value { 256 256 } -command ChangeBinFactor
    $ds9(mb).bin add separator
    $ds9(mb).bin add radiobutton -label {128x128} \
	-variable bin(buffersize) -value 128 -command ChangeBinBufferSize 
    $ds9(mb).bin add radiobutton -label {256x256} \
	-variable bin(buffersize) -value 256 -command ChangeBinBufferSize 
    $ds9(mb).bin add radiobutton -label {512x512} \
	-variable bin(buffersize) -value 512 -command ChangeBinBufferSize 
    $ds9(mb).bin add radiobutton -label {1024x1204} \
	-variable bin(buffersize) -value 1024 -command ChangeBinBufferSize
    $ds9(mb).bin add radiobutton -label {2048x2048} \
	-variable bin(buffersize) -value 2048 -command ChangeBinBufferSize
    $ds9(mb).bin add radiobutton -label {4096x4096} \
	-variable bin(buffersize) -value 4096 -command ChangeBinBufferSize
    $ds9(mb).bin add radiobutton -label {8192x8192} \
	-variable bin(buffersize) -value 8192 -command ChangeBinBufferSize
    $ds9(mb).bin add separator
    $ds9(mb).bin add command -label "[msgcat::mc {Binning Parameters}]..." \
	-command BinDialog

    BinPrefsMenu
}

proc BinPrefsMenu {} {
    global ds9
    global prefs

    menu $ds9(mb).prefs.gui.bin
    $ds9(mb).prefs.gui.bin add radiobutton -label [msgcat::mc {Average}] \
	-variable prefs(bin,function) -value average -command SavePrefs
    $ds9(mb).prefs.gui.bin add radiobutton -label [msgcat::mc {Sum}] \
	-variable prefs(bin,function) -value sum -command SavePrefs
    $ds9(mb).prefs.gui.bin add separator
    $ds9(mb).prefs.gui.bin add radiobutton -label "[msgcat::mc {Block}] 1" \
	-variable prefs(bin,factor) -value { 1 1 } -command SavePrefs
    $ds9(mb).prefs.gui.bin add radiobutton -label "[msgcat::mc {Block}] 2" \
	-variable prefs(bin,factor) -value { 2 2 } -command SavePrefs
    $ds9(mb).prefs.gui.bin add radiobutton -label "[msgcat::mc {Block}] 4" \
	-variable prefs(bin,factor) -value { 4 4 } -command SavePrefs
    $ds9(mb).prefs.gui.bin add radiobutton -label "[msgcat::mc {Block}] 8" \
	-variable prefs(bin,factor) -value { 8 8 } -command SavePrefs
    $ds9(mb).prefs.gui.bin add radiobutton -label "[msgcat::mc {Block}] 16" \
	-variable prefs(bin,factor) -value { 16 16 } -command SavePrefs
    $ds9(mb).prefs.gui.bin add radiobutton -label "[msgcat::mc {Block}] 32" \
	-variable prefs(bin,factor) -value { 32 32 } -command SavePrefs
    $ds9(mb).prefs.gui.bin add radiobutton -label "[msgcat::mc {Block}] 64" \
	-variable prefs(bin,factor) -value { 64 64 } -command SavePrefs
    $ds9(mb).prefs.gui.bin add radiobutton -label "[msgcat::mc {Block}] 128" \
	-variable prefs(bin,factor) -value { 128 128 } -command SavePrefs
    $ds9(mb).prefs.gui.bin add radiobutton -label "[msgcat::mc {Block}] 256" \
	-variable prefs(bin,factor) -value { 256 256 } -command SavePrefs
    $ds9(mb).prefs.gui.bin add separator
    $ds9(mb).prefs.gui.bin add radiobutton -label {128x128} \
	-variable prefs(bin,buffersize) -value 128 -command SavePrefs
    $ds9(mb).prefs.gui.bin add radiobutton -label {256x256} \
	-variable prefs(bin,buffersize) -value 256 -command SavePrefs
    $ds9(mb).prefs.gui.bin add radiobutton -label {512x512} \
	-variable prefs(bin,buffersize) -value 512 -command SavePrefs
    $ds9(mb).prefs.gui.bin add radiobutton -label {1024x1204} \
	-variable prefs(bin,buffersize) -value 1024 -command SavePrefs
    $ds9(mb).prefs.gui.bin add radiobutton -label {2048x2048} \
	-variable prefs(bin,buffersize) -value 2048 -command SavePrefs
    $ds9(mb).prefs.gui.bin add radiobutton -label {4096x4096} \
	-variable prefs(bin,buffersize) -value 4096 -command SavePrefs
    $ds9(mb).prefs.gui.bin add radiobutton -label {8192x8192} \
	-variable prefs(bin,buffersize) -value 8192 -command SavePrefs
}

proc BinButtons {} {
    global ds9

    frame $ds9(buttons).bin
    ButtonButton $ds9(buttons).bin.in \
	[string tolower [msgcat::mc {In}]] {Bin .5 .5}
    ButtonButton $ds9(buttons).bin.out \
	[string tolower [msgcat::mc {Out}]] {Bin 2 2}
    ButtonButton $ds9(buttons).bin.tofit \
	[string tolower [msgcat::mc {To Fit}]] BinToFit
    RadioButton $ds9(buttons).bin.b1 \
	"[string tolower [msgcat::mc {Block}]] 1" \
	bin(factor) { 1 1 } ChangeBinFactor
    RadioButton $ds9(buttons).bin.b2 \
	"[string tolower [msgcat::mc {Block}]] 2" \
	bin(factor) { 2 2 } ChangeBinFactor
    RadioButton $ds9(buttons).bin.b4 \
	"[string tolower [msgcat::mc {Block}]] 4" \
	bin(factor) { 4 4 } ChangeBinFactor
    RadioButton $ds9(buttons).bin.b8 \
	"[string tolower [msgcat::mc {Block}]] 8" \
	bin(factor) { 8 8 } ChangeBinFactor
    RadioButton $ds9(buttons).bin.b16 \
	"[string tolower [msgcat::mc {Block}]] 16" \
	bin(factor) { 16 16 } ChangeBinFactor
    RadioButton $ds9(buttons).bin.b32 \
	"[string tolower [msgcat::mc {Block}]] 32" \
	bin(factor) { 32 32 } ChangeBinFactor
    RadioButton $ds9(buttons).bin.b64 \
	"[string tolower [msgcat::mc {Block}]] 64" \
	bin(factor) { 64 64 } ChangeBinFactor
    RadioButton $ds9(buttons).bin.b128 \
	"[string tolower [msgcat::mc {Block}]] 128" \
	bin(factor) { 128 128 } ChangeBinFactor
    RadioButton $ds9(buttons).bin.b256 \
	"[string tolower [msgcat::mc {Block}]] 256" \
	bin(factor) { 256 256 } ChangeBinFactor
}

proc UpdateBinMenu {} {
    global ds9
    global current
    global bin

    global debug
    if {$debug(tcl,update)} {
	puts "UpdateBinMenu"
    }

    if {$current(frame) != {}} {
	if {[$current(frame) has fits]} {
	    if {[$current(frame) has bin]} {
		$ds9(mb) entryconfig [msgcat::mc {Bin}] -state normal
		$ds9(buttons).major.bin configure -state normal
	    } else {
		$ds9(mb) entryconfig [msgcat::mc {Bin}] -state disabled
		$ds9(buttons).major.bin configure -state disabled
	    }
	} else {
	    $ds9(mb) entryconfig [msgcat::mc {Bin}] -state normal
	    $ds9(buttons).major.bin configure -state normal
	}

	set bin(function) [$current(frame) get bin function]
	set bin(factor) "[$current(frame) get bin factor]"
	set bin(depth) [$current(frame) get bin depth]
	set bin(buffersize) [$current(frame) get bin buffer size]
    } else {
	$ds9(mb) entryconfig [msgcat::mc {Bin}] -state disabled
	$ds9(buttons).major.bin configure -state disabled
    }
}

