#  Copyright (C) 1999-2007
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc ColorMenu {} {
    global ds9

    menu $ds9(mb).color
    $ds9(mb).color add separator
    $ds9(mb).color add checkbutton -label [msgcat::mc {Invert Colormap}] \
	-variable colorbar(invert) -command InvertColorbar
    $ds9(mb).color add command -label [msgcat::mc {Reset Colormap}] \
	-command ResetColormap
    $ds9(mb).color add separator
    $ds9(mb).color add command -label "[msgcat::mc {Colormap Parameters}]..." \
	-command ColormapDialog

    ColorPrefsMenu
}

proc ColorPrefsMenu {} {
    global ds9
    global prefs

    menu $ds9(mb).prefs.gui.color
    $ds9(mb).prefs.gui.color add separator
    $ds9(mb).prefs.gui.color add checkbutton \
	-label [msgcat::mc {Invert Colormap}] \
	-variable prefs(colorbar,invert) -command SavePrefs
}

proc ColorButtons {} {
    global ds9
    global colorbar

    set ids [colorbar list id]

    frame $ds9(buttons).color1
    for {set i 0} {$i<9} {incr i} {
	set id [lindex $ids $i]
	set title [colorbar get name $id]
	set name [string tolower $title]
	RadioButton $ds9(buttons).color1.$i $name \
	    colorbar(map) $title "ChangeColormapID $id"
    }
    RadioButton $ds9(buttons).color1.more \
	[string tolower [msgcat::mc {More}]] \
	buttons(majorCurrent) $ds9(buttons).color2 MajorButton

    frame $ds9(buttons).color2
    for {set i 9} {$i<18} {incr i} {
	set id [lindex $ids $i]
	set title [colorbar get name $id]
	set name [string tolower $title]
	RadioButton $ds9(buttons).color2.$i $name \
	    colorbar(map) $title "ChangeColormapID $id"
    }
    RadioButton $ds9(buttons).color2.more \
	[string tolower [msgcat::mc {More}]] \
	buttons(majorCurrent) $ds9(buttons).color3 MajorButton

    frame $ds9(buttons).color3
    CheckButton $ds9(buttons).color3.invert \
	[string tolower [msgcat::mc {Invert}]] colorbar(invert) InvertColorbar
    ButtonButton $ds9(buttons).color3.reset \
	[string tolower [msgcat::mc {Reset}]] ResetColormap
    RadioButton $ds9(buttons).color3.more \
	[string tolower [msgcat::mc {More}]] \
	buttons(majorCurrent) $ds9(buttons).color1 MajorButton
}

proc UpdateColorMenu {} {
    global ds9
    global current
    global colorbar

    global debug
    if {$debug(tcl,update)} {
	puts "UpdateColorMenu"
    }

    if {$current(frame) != {}} {
	if {[$current(frame) get type] == {rgb}} {
	    for {set i 1} {$i<$colorbar(count)} {incr i} {
		$ds9(mb).color entryconfig $i -state disabled
	    }

	    for {set i 0} {$i<$colorbar(button1)} {incr i} {
		$ds9(buttons).color1.$i configure -state disabled
	    }
	    for {set i $colorbar(button1)} {$i<$colorbar(button2)} {incr i} {
		$ds9(buttons).color2.$i configure -state disabled
	    }
	} else {
	    for {set i 1} {$i<$colorbar(count)} {incr i} {
		$ds9(mb).color entryconfig $i -state normal
	    }

	    for {set i 0} {$i<$colorbar(button1)} {incr i} {
		$ds9(buttons).color1.$i configure -state normal
	    }
	    for {set i $colorbar(button1)} {$i<$colorbar(button2)} {incr i} {
		$ds9(buttons).color2.$i configure -state normal
	    }
	}
    } else {
	for {set i 1} {$i<$colorbar(count)} {incr i} {
	    $ds9(mb).color entryconfig $i -state normal
	}

	for {set i 0} {$i<$colorbar(button1)} {incr i} {
	    $ds9(buttons).color1.$i configure -state normal
	}
	for {set i $colorbar(button1)} {$i<$colorbar(button2)} {incr i} {
	    $ds9(buttons).color2.$i configure -state normal
	}
    }
}

