#  Copyright (C) 1999-2007
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc FileMenu {} {
    global ds9

    switch [tk windowingsystem] {
	x11 -
	win32 {
	    menu $ds9(mb).file 
	    $ds9(mb).file add command \
		-label "[msgcat::mc {About SAOImage DS9}]..." \
		-command AboutBox
	    $ds9(mb).file add separator
	}
	aqua {
	    menu $ds9(mb).apple -title {DS9}
	    $ds9(mb).apple add command \
		-label [msgcat::mc {About SAOImage DS9}] \
		-command AboutBox
	    menu $ds9(mb).file 
	}
    }
    $ds9(mb).file add command -label "[msgcat::mc {Open}]..." \
	-command {OpenFits {}}
    $ds9(mb).file add cascade -label [msgcat::mc {Open Other}] \
	-menu $ds9(mb).file.open
    $ds9(mb).file add separator
#    $ds9(mb).file add command -label "[msgcat::mc {Open Mask}]..." 
#	-command {OpenFits mask}
#    $ds9(mb).file add cascade -label [msgcat::mc {Open Mask Other}] 
#	-menu $ds9(mb).file.mask
#    $ds9(mb).file add separator
    $ds9(mb).file add cascade -label [msgcat::mc {Preserve During Load}] \
	-menu $ds9(mb).file.preserve
    $ds9(mb).file add separator
    $ds9(mb).file add command -label "[msgcat::mc {Save Image}]..." \
	-command SaveImageDialog
    $ds9(mb).file add command -label "[msgcat::mc {Save Frame as Fits}]..." \
	-command SaveFitsDialog
    $ds9(mb).file add command -label "[msgcat::mc {Save Frames as MPEG}]..." \
	-command SaveMPEGDialog
    $ds9(mb).file add separator
    $ds9(mb).file add command -label "[msgcat::mc {Display Fits Header}]..." \
	-command DisplayHeaderMenu 
    $ds9(mb).file add separator
    $ds9(mb).file add command -label "[msgcat::mc {XPA Information}]..." \
	-command DisplayXPAInfo
    $ds9(mb).file add command -label "[msgcat::mc {Source TCL}]..." \
	-command OpenSource
    $ds9(mb).file add separator
    $ds9(mb).file add command -label "[msgcat::mc {Print}]..." \
	-command Print
    $ds9(mb).file add command -label "[msgcat::mc {Page Setup}]..." \
	-command PageSetupDialog
    switch [tk windowingsystem] {
	x11 -
	win32 {
	    $ds9(mb).file add separator
	    $ds9(mb).file add command \
		-label [msgcat::mc {Exit}] -command QuitDS9
	}
	aqua {}
    }

    # File Open Menu
    menu $ds9(mb).file.open
    $ds9(mb).file.open add command -label "[msgcat::mc {Open Array}]..." \
	-command {OpenArray {}}
    $ds9(mb).file.open add command -label "[msgcat::mc {Open URL}]..." \
	-command OpenURL
    $ds9(mb).file.open add separator
    $ds9(mb).file.open add command \
	-label "[msgcat::mc {Open RGB Fits Image}]..." \
	-command OpenRGBImageFits
    $ds9(mb).file.open add command \
	-label "[msgcat::mc {Open RGB Fits Cube}]..."\
	-command OpenRGBCubeFits
    $ds9(mb).file.open add command \
	-label "[msgcat::mc {Open RGB Array}]..." \
	-command OpenRGBArray
    $ds9(mb).file.open add separator
    $ds9(mb).file.open add command \
	-label "[msgcat::mc {Open Multi Ext as Data Cube}]..." \
	-command {OpenDataCubeFits {}}
    $ds9(mb).file.open add separator
    $ds9(mb).file.open add command \
	-label "[msgcat::mc {Open Mosaic IRAF}]..." \
	-command {OpenMosaicImageIRAFFits {}}
    $ds9(mb).file.open add command \
	-label "[msgcat::mc {Open Mosaic IRAF Segment}]..." \
	-command {OpenMosaicIRAFFits {}}
    $ds9(mb).file.open add separator
    $ds9(mb).file.open add command \
	-label "[msgcat::mc {Open Mosaic WCS}]..." \
	-command {OpenMosaicImageWCSFits {}}
    $ds9(mb).file.open add command \
	-label "[msgcat::mc {Open Mosaic WCS Segment}]..." \
	-command {OpenMosaicWCSFits {}}
    $ds9(mb).file.open add separator
    $ds9(mb).file.open add command \
	-label "[msgcat::mc {Open Mosaic WFPC2}]..." \
	-command {OpenMosaicImageWFPC2Fits {}}

    # Open Mask
    menu $ds9(mb).file.mask
    $ds9(mb).file.mask add command \
	-label "[msgcat::mc {Open Array}]..." \
	-command {OpenArray mask}
    $ds9(mb).file.mask add separator
    $ds9(mb).file.mask add command \
	-label "[msgcat::mc {Open Multi Ext as Data Cube}]..." \
	-command {OpenDataCubeFits mask}
    $ds9(mb).file.mask add separator
    $ds9(mb).file.mask add command \
	-label "[msgcat::mc {Open Mosaic IRAF}]..." \
	-command {OpenMosaicImageIRAFFits mask}
    $ds9(mb).file.mask add command \
	-label "[msgcat::mc {Open Mosaic IRAF Segment}]..." \
	-command {OpenMosaicIRAFFits mask}
    $ds9(mb).file.mask add separator
    $ds9(mb).file.mask add command \
	-label "[msgcat::mc {Open Mosaic WCS}]..." \
	-command {OpenMosaicImageWCSFits mask}
    $ds9(mb).file.mask add command \
	-label "[msgcat::mc {Open Mosaic WCS Segment}]..." \
	-command {OpenMosaicWCSFits mask}
    $ds9(mb).file.mask add separator
    $ds9(mb).file.mask add command \
	-label "[msgcat::mc {Open Mosaic WFPC2}]..." \
	-command {OpenMosaicImageWFPC2Fits {}}

    # File Preserve Menu
    menu $ds9(mb).file.preserve
    $ds9(mb).file.preserve add checkbutton -label [msgcat::mc {Scale}] \
	-variable scale(preserve) -command PreserveScale
    $ds9(mb).file.preserve add checkbutton -label [msgcat::mc {Pan}] \
	-variable panzoom(preserve) -command PreservePan
    $ds9(mb).file.preserve add checkbutton -label [msgcat::mc {Regions}] \
	-variable marker(preserve) -command MarkerPreserve

    FilePrefsMenu
}

proc FilePrefsMenu {} {
    global ds9
    global prefs

    menu $ds9(mb).prefs.gui.file
    $ds9(mb).prefs.gui.file add command -label "[msgcat::mc {Print}]..." \
	-command {PrefsPrintDialog ps}
    $ds9(mb).prefs.gui.file add command -label "[msgcat::mc {Page Setup}]..." \
	-command PrefsPageSetupDialog
}

proc FileButtons {} {
    global ds9

    frame $ds9(buttons).file

    ButtonButton $ds9(buttons).file.about \
	[string tolower [msgcat::mc {About}]] AboutBox
    ButtonButton $ds9(buttons).file.open \
	[string tolower [msgcat::mc {Open}]] {OpenFits {}}
    ButtonButton $ds9(buttons).file.saveimage \
	[string tolower [msgcat::mc {Save Image}]] SaveImageDialog
    ButtonButton $ds9(buttons).file.savefits \
	[string tolower [msgcat::mc {Save Fits}]] SaveFitsDialog
    ButtonButton $ds9(buttons).file.savempeg \
	[string tolower [msgcat::mc {Save MPEG}]] SaveMPEGDialog
    ButtonButton $ds9(buttons).file.header \
	[string tolower [msgcat::mc {Header}]] DisplayHeaderMenu
    ButtonButton $ds9(buttons).file.print \
	[string tolower [msgcat::mc {Print}]] Print
    ButtonButton $ds9(buttons).file.page \
	[string tolower [msgcat::mc {Page Setup}]] PageSetupDialog
    ButtonButton $ds9(buttons).file.exit \
	[string tolower [msgcat::mc {Exit}]] QuitDS9
}

proc UpdateFileMenu {} {
    global ds9
    global current
    global crosshair
 
    global debug
    if {$debug(tcl,update)} {
	puts "UpdateFileMenu"
    }

    if {$current(frame) != {}} {
	$ds9(mb).file entryconfig "[msgcat::mc {Open}]..." \
	    -state normal
	$ds9(mb).file entryconfig [msgcat::mc {Open Other}] \
	    -state normal
	$ds9(mb).file entryconfig "[msgcat::mc {Save Image}]..." \
	    -state normal
	$ds9(mb).file entryconfig "[msgcat::mc {Save Frame as Fits}]..." \
	    -state normal
	$ds9(mb).file entryconfig "[msgcat::mc {Save Frames as MPEG}]..." \
	    -state normal
	$ds9(mb).file entryconfig "[msgcat::mc {Display Fits Header}]..." \
	    -state disabled
	$ds9(mb).file entryconfig "[msgcat::mc {Print}]..." \
	    -state normal

	if {[$current(frame) get type] == {rgb}} {
	    $ds9(mb).file.open entryconfig \
		"[msgcat::mc {Open RGB Fits Image}]..." -state normal
	    $ds9(mb).file.open entryconfig \
		"[msgcat::mc {Open RGB Fits Cube}]..." -state normal
	    $ds9(mb).file.open entryconfig \
		"[msgcat::mc {Open RGB Array}]..." -state normal
	} else {
	    $ds9(mb).file.open entryconfig \
		"[msgcat::mc {Open RGB Fits Image}]..." -state disabled
	    $ds9(mb).file.open entryconfig \
		"[msgcat::mc {Open RGB Fits Cube}]..." -state disabled
	    $ds9(mb).file.open entryconfig \
		"[msgcat::mc {Open RGB Array}]..." -state disabled
	}

	$ds9(buttons).file.open configure -state normal
	$ds9(buttons).file.saveimage configure -state normal
	$ds9(buttons).file.savefits configure -state normal
	$ds9(buttons).file.savempeg configure -state normal
	$ds9(buttons).file.header configure -state disabled
	$ds9(buttons).file.print configure -state normal

	if {[$current(frame) has fits]} {
	    $ds9(mb).file entryconfig \
		"[msgcat::mc {Display Fits Header}]..." -state normal
	    $ds9(buttons).file.header configure -state normal
	}

	if {[$current(frame) has fits]} {
#	    $ds9(mb).file entryconfig 
#		"[msgcat::mc {Open Mask}]..." -state normal
#	    $ds9(mb).file entryconfig 
#		[msgcat::mc {Open Mask Other}] 	-state normal

	    if {[$current(frame) has fits cube]} {
		$ds9(mb).file.mask entryconfig \
		    "[msgcat::mc {Open Multi Ext as Data Cube}]..." \
		    -state normal
	    } else {
		$ds9(mb).file.mask entryconfig \
		    "[msgcat::mc {Open Multi Ext as Data Cube}]..." \
		    -state disabled
	    }

	    if {[$current(frame) has fits mosaic]} {
		$ds9(mb).file.mask entryconfig \
		    "[msgcat::mc {Open Mosaic IRAF}]..." -state normal
		$ds9(mb).file.mask entryconfig \
		    "[msgcat::mc {Open Mosaic IRAF Segment}]..." -state normal
		$ds9(mb).file.mask entryconfig \
		    "[msgcat::mc {Open Mosaic WCS}]..." -state normal
		$ds9(mb).file.mask entryconfig \
		    "[msgcat::mc {Open Mosaic WCS Segment}]..." -state normal
		$ds9(mb).file.mask entryconfig \
		    "[msgcat::mc {Open Mosaic WFPC2}]..." -state normal
	    } else {
		$ds9(mb).file.mask entryconfig \
		    "[msgcat::mc {Open Mosaic IRAF}]..." -state disabled
		$ds9(mb).file.mask entryconfig \
		    "[msgcat::mc {Open Mosaic IRAF Segment}]..." \
		    -state disabled
		$ds9(mb).file.mask entryconfig \
		    "[msgcat::mc {Open Mosaic WCS}]..." -state disabled
		$ds9(mb).file.mask entryconfig \
		    "[msgcat::mc {Open Mosaic WCS Segment}]..." -state disabled
		$ds9(mb).file.mask entryconfig \
		    "[msgcat::mc {Open Mosaic WFPC2}]..." -state disabled
	    }

	} else {
#	    $ds9(mb).file entryconfig "[msgcat::mc {Open Mask}]..." 
#		-state disabled
#	    $ds9(mb).file entryconfig [msgcat::mc {Open Mask Other}] 
#		-state disabled
	}
	
    } else {
	$ds9(mb).file entryconfig "[msgcat::mc {Open}]..." \
	    -state disabled
	$ds9(mb).file entryconfig [msgcat::mc {Open Other}] \
	    -state disabled
#	$ds9(mb).file entryconfig "[msgcat::mc {Open Mask}]..." 
#	    -state disabled
#	$ds9(mb).file entryconfig [msgcat::mc {Open Mask Other}] 
#	    -state disabled
	$ds9(mb).file entryconfig "[msgcat::mc {Save Image}]..." \
	    -state disabled
	$ds9(mb).file entryconfig "[msgcat::mc {Save Frame as Fits}]..." \
	    -state disabled
	$ds9(mb).file entryconfig "[msgcat::mc {Save Frames as MPEG}]..." \
	    -state disabled
	$ds9(mb).file entryconfig "[msgcat::mc {Display Fits Header}]..." \
	    -state disabled
	$ds9(mb).file entryconfig "[msgcat::mc {Print}]..." \
	    -state disabled

	$ds9(buttons).file.open configure -state disabled
	$ds9(buttons).file.saveimage configure -state disabled
	$ds9(buttons).file.savefits configure -state disabled
	$ds9(buttons).file.savempeg configure -state disabled
	$ds9(buttons).file.header configure -state disabled
	$ds9(buttons).file.print configure -state disabled
    }
}

