#  Copyright (C) 1999-2007
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc RegionMenu {} {
    global ds9

    menu $ds9(mb).region
    $ds9(mb).region add checkbutton -label [msgcat::mc {Show Regions}] \
	-variable marker(show) -command MarkerShow
    $ds9(mb).region add checkbutton -label [msgcat::mc {Show Regions Text}] \
	-variable marker(show,text) -command MarkerShowText
    $ds9(mb).region add separator
    $ds9(mb).region add command -label "[msgcat::mc {Get Information}]..." \
	-command MarkerInfo
    $ds9(mb).region add separator
    $ds9(mb).region add cascade -label [msgcat::mc {Shape}] \
	-menu $ds9(mb).region.shape
    $ds9(mb).region add cascade -label [msgcat::mc {Color}] \
	-menu $ds9(mb).region.color
    $ds9(mb).region add cascade -label [msgcat::mc {Width}] \
	-menu $ds9(mb).region.width
    $ds9(mb).region add cascade -label [msgcat::mc {Properties}] \
	-menu $ds9(mb).region.properties
    $ds9(mb).region add cascade -label [msgcat::mc {Font}] \
	-menu $ds9(mb).region.font
    $ds9(mb).region add separator
    $ds9(mb).region add command -label [msgcat::mc {Move to Front}] \
	-command MarkerFront
    $ds9(mb).region add command -label [msgcat::mc {Move to Back}] \
	-command MarkerBack
    $ds9(mb).region add separator
    $ds9(mb).region add command -label [msgcat::mc {Select All}] \
	-command MarkerSelectAll
    $ds9(mb).region add command -label [msgcat::mc {Select None}] \
	-command MarkerUnselectAll
    $ds9(mb).region add command -label [msgcat::mc {Invert Selection}] \
	-command MarkerSelectInvert
    $ds9(mb).region add separator
    $ds9(mb).region add command -label [msgcat::mc {Delete Selected Regions}] \
	-command MarkerDeleteSelect
    $ds9(mb).region add command -label [msgcat::mc {Delete All Regions}] \
	-command MarkerDeleteAllMenu
    $ds9(mb).region add separator
    $ds9(mb).region add command -label [msgcat::mc {New Group}] \
	-command GroupCreate
    $ds9(mb).region add command -label "[msgcat::mc {Groups}]..." \
	-command GroupDialog
    $ds9(mb).region add separator
    $ds9(mb).region add command -label [msgcat::mc {Create Composite Region}] \
	-command CompositeCreate
    $ds9(mb).region add command \
	-label [msgcat::mc {Dissolve Composite Region}] \
	-command CompositeDelete
    $ds9(mb).region add separator
    $ds9(mb).region add command -label "[msgcat::mc {Load Template}]..." \
	-command OpenTemplateMarker
    $ds9(mb).region add command -label "[msgcat::mc {Save as Template}]..." \
	-command SaveAsTemplateMarker
    $ds9(mb).region add separator
    $ds9(mb).region add command -label [msgcat::mc {List Regions}] \
	-command MarkerDisplay
    $ds9(mb).region add command -label "[msgcat::mc {Load Regions}]..." \
	-command MarkerOpen
    $ds9(mb).region add command -label "[msgcat::mc {Save Regions}]..." \
	-command MarkerSave
    $ds9(mb).region add separator
    $ds9(mb).region add cascade -label [msgcat::mc {File Format}] \
	-menu $ds9(mb).region.format
    $ds9(mb).region add cascade -label [msgcat::mc {File Coordinate System}] \
	-menu $ds9(mb).region.coord

    menu $ds9(mb).region.shape
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Circle}] \
	-variable marker(shape) -value circle
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Ellipse}] \
	-variable marker(shape) -value ellipse
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Box}] \
	-variable marker(shape) -value box
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Polygon}] \
	-variable marker(shape) -value polygon
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Line}] \
	-variable marker(shape) -value line
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Vector}] \
	-variable marker(shape) -value vector
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Text}] \
	-variable marker(shape) -value text
    $ds9(mb).region.shape add separator
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Ruler}] \
	-variable marker(shape) -value ruler
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Compass}] \
	-variable marker(shape) -value compass
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Projection}] \
	-variable marker(shape) -value projection
    $ds9(mb).region.shape add separator
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Annulus}] \
	-variable marker(shape) -value annulus
    $ds9(mb).region.shape add radiobutton \
	-label [msgcat::mc {Elliptical Annulus}] \
	-variable marker(shape) -value ellipseannulus
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Box Annulus}] \
	-variable marker(shape) -value boxannulus
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Panda}] \
	-variable marker(shape) -value panda
    $ds9(mb).region.shape add radiobutton \
	-label [msgcat::mc {Elliptical Panda}]\
	-variable marker(shape) -value epanda
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Box Panda}] \
	-variable marker(shape) -value bpanda
    $ds9(mb).region.shape add separator
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Circle Point}] \
	-variable marker(shape) -value {circle point} 
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Box Point}] \
	-variable marker(shape) -value {box point}
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Diamond Point}] \
	-variable marker(shape) -value {diamond point}
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Cross Point}] \
	-variable marker(shape) -value {cross point}
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {X Point}] \
	-variable marker(shape) -value {x point}
    $ds9(mb).region.shape add radiobutton -label [msgcat::mc {Arrow Point}] \
	-variable marker(shape) -value {arrow point} 
    $ds9(mb).region.shape add radiobutton \
	-label [msgcat::mc {BoxCircle Point}] \
	-variable marker(shape) -value {boxcircle point}
    $ds9(mb).region.shape add separator
    $ds9(mb).region.shape add cascade -label [msgcat::mc {Instrument FOV}] \
	-menu $ds9(mb).region.shape.template

    CreateTemplateMenu

    menu $ds9(mb).region.color
    $ds9(mb).region.color add radiobutton -label [msgcat::mc {Black}] \
	-variable marker(color) -value black -command MarkerColor
    $ds9(mb).region.color add radiobutton -label [msgcat::mc {White}] \
	-variable marker(color) -value white -command MarkerColor
    $ds9(mb).region.color add radiobutton -label [msgcat::mc {Red}] \
	-variable marker(color) -value red -command MarkerColor
    $ds9(mb).region.color add radiobutton -label [msgcat::mc {Green}] \
	-variable marker(color) -value green -command MarkerColor
    $ds9(mb).region.color add radiobutton -label [msgcat::mc {Blue}] \
	-variable marker(color) -value blue -command MarkerColor
    $ds9(mb).region.color add radiobutton -label [msgcat::mc {Cyan}] \
	-variable marker(color) -value cyan -command MarkerColor
    $ds9(mb).region.color add radiobutton -label [msgcat::mc {Magenta}] \
	-variable marker(color) -value magenta -command MarkerColor
    $ds9(mb).region.color add radiobutton -label [msgcat::mc {Yellow}] \
	-variable marker(color) -value yellow -command MarkerColor

    menu $ds9(mb).region.width
    $ds9(mb).region.width add radiobutton -label {1} \
	-variable marker(width) -value 1 -command MarkerWidth
    $ds9(mb).region.width add radiobutton -label {2} \
	-variable marker(width) -value 2 -command MarkerWidth
    $ds9(mb).region.width add radiobutton -label {3} \
	-variable marker(width) -value 3 -command MarkerWidth
    $ds9(mb).region.width add radiobutton -label {4} \
	-variable marker(width) -value 4 -command MarkerWidth

    menu $ds9(mb).region.properties
    $ds9(mb).region.properties add checkbutton \
	-label [msgcat::mc {Can Edit}] \
	-variable marker(edit) -command {MarkerProp edit}
    $ds9(mb).region.properties add checkbutton \
	-label [msgcat::mc {Can Move}] \
	-variable marker(move) -command {MarkerProp move}
    $ds9(mb).region.properties add checkbutton \
	-label [msgcat::mc {Can Rotate}] \
	-variable marker(rotate) -command {MarkerProp rotate}
    $ds9(mb).region.properties add checkbutton \
	-label [msgcat::mc {Can Delete}] \
	-variable marker(delete) -command {MarkerProp delete}
    $ds9(mb).region.properties add checkbutton \
	-label [msgcat::mc {Fixed in Size}] \
	-variable marker(fixed) -command {MarkerProp fixed}
    $ds9(mb).region.properties add separator
    $ds9(mb).region.properties add radiobutton \
	-label [msgcat::mc {Include}] \
	-variable marker(include) -value 1 -command {MarkerProp include}
    $ds9(mb).region.properties add radiobutton \
	-label [msgcat::mc {Exclude}] \
	-variable marker(include) -value 0 -command {MarkerProp include}
    $ds9(mb).region.properties add separator
    $ds9(mb).region.properties add radiobutton \
	-label [msgcat::mc {Source}] \
	-variable marker(source) -value 1 -command {MarkerProp source}
    $ds9(mb).region.properties add radiobutton \
	-label [msgcat::mc {Background}] \
	-variable marker(source) -value 0 -command {MarkerProp source}

    menu $ds9(mb).region.font
    $ds9(mb).region.font add radiobutton -label [msgcat::mc {Times}] \
	-variable marker(font) -value times -command MarkerFont
    $ds9(mb).region.font add radiobutton -label [msgcat::mc {Helvetica}] \
	-variable marker(font) -value helvetica -command MarkerFont
    $ds9(mb).region.font add radiobutton -label [msgcat::mc {Symbol}] \
	-variable marker(font) -value symbol -command MarkerFont
    $ds9(mb).region.font add radiobutton -label [msgcat::mc {Courier}] \
	-variable marker(font) -value courier -command MarkerFont
    $ds9(mb).region.font add separator
    $ds9(mb).region.font add radiobutton -label {9} \
	-variable marker(font,size) -value 9 -command MarkerFont
    $ds9(mb).region.font add radiobutton -label {10} \
	-variable marker(font,size) -value 10 -command MarkerFont
    $ds9(mb).region.font add radiobutton -label {12} \
	-variable marker(font,size) -value 12 -command MarkerFont
    $ds9(mb).region.font add radiobutton -label {14} \
	-variable marker(font,size) -value 14 -command MarkerFont
    $ds9(mb).region.font add radiobutton -label {18} \
	-variable marker(font,size) -value 18 -command MarkerFont
    $ds9(mb).region.font add radiobutton -label {24} \
	-variable marker(font,size) -value 24 -command MarkerFont
    $ds9(mb).region.font add radiobutton -label {30} \
	-variable marker(font,size) -value 30 -command MarkerFont
    $ds9(mb).region.font add radiobutton -label {36} \
	-variable marker(font,size) -value 36 -command MarkerFont
    $ds9(mb).region.font add radiobutton -label {72} \
	-variable marker(font,size) -value 72 -command MarkerFont
    $ds9(mb).region.font add separator
    $ds9(mb).region.font add radiobutton -label [msgcat::mc {Plain}] \
	-variable marker(font,style) -value normal -command MarkerFont
    $ds9(mb).region.font add radiobutton -label [msgcat::mc {Bold}] \
	-variable marker(font,style) -value bold -command MarkerFont
    $ds9(mb).region.font add radiobutton -label [msgcat::mc {Italic}] \
	-variable marker(font,style) -value italic -command MarkerFont

    menu $ds9(mb).region.format
    $ds9(mb).region.format add radiobutton -label {DS9/Funtools} \
	-variable marker(format) -value ds9 -command UpdateMarkerFormatMenu
    $ds9(mb).region.format add radiobutton -label {Ciao} \
	-variable marker(format) -value ciao -command UpdateMarkerFormatMenu
    $ds9(mb).region.format add radiobutton -label {SAOtng} \
	-variable marker(format) -value saotng -command UpdateMarkerFormatMenu
    $ds9(mb).region.format add radiobutton -label {SAOimage} \
	-variable marker(format) -value saoimage \
	-command UpdateMarkerFormatMenu
    $ds9(mb).region.format add radiobutton -label {IRAF PROS} \
	-variable marker(format) -value pros -command UpdateMarkerFormatMenu
    $ds9(mb).region.format add radiobutton -label {X Y} \
	-variable marker(format) -value xy -command UpdateMarkerFormatMenu
    $ds9(mb).region.format add separator
    $ds9(mb).region.format add checkbutton -label [msgcat::mc {Strip Output}] \
	-variable marker(strip)
    $ds9(mb).region.format add checkbutton -label [msgcat::mc {List WCS}] \
	-variable marker(wcs)

    menu $ds9(mb).region.coord
    $ds9(mb).region.coord add radiobutton -label [msgcat::mc {WCS}] \
	-variable marker(system) -value wcs \
	-command UpdateMarkerFormatMenu
    $ds9(mb).region.coord add cascade -label [msgcat::mc {Multiple WCS}] \
	-menu $ds9(mb).region.coord.wcs
    $ds9(mb).region.coord add separator
    $ds9(mb).region.coord add radiobutton -label [msgcat::mc {Image}] \
	-variable marker(system) -value image \
	-command UpdateMarkerFormatMenu
    $ds9(mb).region.coord add radiobutton -label [msgcat::mc {Physical}] \
	-variable marker(system) -value physical \
	-command UpdateMarkerFormatMenu
    $ds9(mb).region.coord add radiobutton -label [msgcat::mc {Amplifier}] \
	-variable marker(system) -value amplifier \
	-command UpdateMarkerFormatMenu
    $ds9(mb).region.coord add radiobutton -label [msgcat::mc {Detector}] \
	-variable marker(system) -value detector \
	-command UpdateMarkerFormatMenu
    $ds9(mb).region.coord add separator
    $ds9(mb).region.coord add radiobutton \
	-label "[msgcat::mc {Equatorial}] B1950" \
	-variable marker(sky) -value fk4
    $ds9(mb).region.coord add radiobutton \
	-label "[msgcat::mc {Equatorial}] J2000" \
	-variable marker(sky) -value fk5
    $ds9(mb).region.coord add radiobutton -label [msgcat::mc {ICRS}] \
	-variable marker(sky) -value icrs
    $ds9(mb).region.coord add radiobutton -label [msgcat::mc {Galactic}] \
	-variable marker(sky) -value galactic
    $ds9(mb).region.coord add radiobutton -label [msgcat::mc {Ecliptic}] \
	-variable marker(sky) -value ecliptic
    $ds9(mb).region.coord add separator
    $ds9(mb).region.coord add radiobutton -label [msgcat::mc {Degrees}] \
	-variable marker(skyformat) -value degrees
    $ds9(mb).region.coord add radiobutton -label {Sexagesimal} \
	-variable marker(skyformat) -value sexagesimal

    menu $ds9(mb).region.coord.wcs
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$ds9(mb).region.coord.wcs add radiobutton \
	    -label "[msgcat::mc {WCS}] $l" \
	    -variable marker(system) -value "wcs$l" \
	    -command UpdateMarkerFormatMenu
    }

    RegionPrefsMenu
}

proc RegionPrefsMenu {} {
    global ds9
    global prefs

    set menu(prefs,region,default) [msgcat::mc {Default Dialog}]
    set menu(prefs,region,coord) [msgcat::mc {Coordinate System}]
    set menu(prefs,region,dist) [msgcat::mc {Distance System}]

    menu $ds9(mb).prefs.gui.region
    $ds9(mb).prefs.gui.region add cascade -label [msgcat::mc {Shape}] \
	-menu $ds9(mb).prefs.gui.region.shape
    $ds9(mb).prefs.gui.region add cascade -label [msgcat::mc {Color}] \
	-menu $ds9(mb).prefs.gui.region.color
    $ds9(mb).prefs.gui.region add cascade -label [msgcat::mc {Width}] \
	-menu $ds9(mb).prefs.gui.region.width
    $ds9(mb).prefs.gui.region add cascade -label [msgcat::mc {Properties}] \
	-menu $ds9(mb).prefs.gui.region.properties
    $ds9(mb).prefs.gui.region add cascade -label [msgcat::mc {Font}] \
	-menu $ds9(mb).prefs.gui.region.font
    $ds9(mb).prefs.gui.region add separator
    $ds9(mb).prefs.gui.region add command -label [msgcat::mc {Circle}] \
	-command PrefsMarkerCircle
    $ds9(mb).prefs.gui.region add command -label [msgcat::mc {Ellipse}] \
	-command PrefsMarkerEllipse
    $ds9(mb).prefs.gui.region add command -label [msgcat::mc {Box}] \
	-command PrefsMarkerBox
    $ds9(mb).prefs.gui.region add command -label [msgcat::mc {Projection}] \
	-command PrefsMarkerProjection
    $ds9(mb).prefs.gui.region add separator
    $ds9(mb).prefs.gui.region add command -label [msgcat::mc {Annulus}] \
	-command PrefsMarkerAnnulus
    $ds9(mb).prefs.gui.region add command \
	-label [msgcat::mc {Elliptical Annulus}] \
	-command PrefsMarkerEllipseAnnulus
    $ds9(mb).prefs.gui.region add command -label [msgcat::mc {Box Annulus}] \
	-command PrefsMarkerBoxAnnulus
    $ds9(mb).prefs.gui.region add command -label [msgcat::mc {Panda}] \
	-command PrefsMarkerPanda
    $ds9(mb).prefs.gui.region add command \
	-label [msgcat::mc {Elliptical Panda}] \
	-command PrefsMarkerEpanda
    $ds9(mb).prefs.gui.region add command -label [msgcat::mc {Box Panda}] \
	-command PrefsMarkerBpanda
    $ds9(mb).prefs.gui.region add separator
    $ds9(mb).prefs.gui.region add cascade -label [msgcat::mc {File Format}] \
	-menu $ds9(mb).prefs.gui.region.format
    $ds9(mb).prefs.gui.region add cascade \
	-label [msgcat::mc {File Coordinate System}] \
	-menu $ds9(mb).prefs.gui.region.coord
    $ds9(mb).prefs.gui.region add separator
    $ds9(mb).prefs.gui.region add cascade -label [msgcat::mc {Default Dialog}]\
	-menu $ds9(mb).prefs.gui.region.dialog

    menu $ds9(mb).prefs.gui.region.shape
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label [msgcat::mc {Circle}] \
	-variable prefs(marker,shape) -value circle -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label [msgcat::mc {Ellipse}] \
	-variable prefs(marker,shape) -value ellipse -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label [msgcat::mc {Box}] \
	-variable prefs(marker,shape) -value box -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label [msgcat::mc {Polygon}] \
	-variable prefs(marker,shape) -value polygon -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label [msgcat::mc {Line}] \
	-variable prefs(marker,shape) -value line -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label [msgcat::mc {Vector}] \
	-variable prefs(marker,shape) -value vector -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label [msgcat::mc {Text}] \
	-variable prefs(marker,shape) -value text -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add separator
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label [msgcat::mc {Ruler}] \
	-variable prefs(marker,shape) -value ruler -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label [msgcat::mc {Compass}] \
	-variable prefs(marker,shape) -value compass -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label [msgcat::mc {Projection}] \
	-variable prefs(marker,shape) -value projection -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add separator
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label [msgcat::mc {Annulus}] \
	-variable prefs(marker,shape) -value annulus -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label [msgcat::mc {Elliptical Annulus}] \
	-variable prefs(marker,shape) -value ellipseannulus -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label [msgcat::mc {Box Annulus}] \
	-variable prefs(marker,shape) -value boxannulus -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label [msgcat::mc {Panda}] \
	-variable prefs(marker,shape) -value panda -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label [msgcat::mc {Elliptical Panda}] \
	-variable prefs(marker,shape) -value epanda -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label [msgcat::mc {Box Panda}] \
	-variable prefs(marker,shape) -value bpanda -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add separator
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label [msgcat::mc {Circle Point}] \
	-variable prefs(marker,shape) -value {circle point} -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label [msgcat::mc {Box Point}] \
	-variable prefs(marker,shape) -value {box point}  -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label [msgcat::mc {Diamond Point}] \
	-variable prefs(marker,shape) -value {diamond point} -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label [msgcat::mc {Cross Point}] \
	-variable prefs(marker,shape) -value {cross point} -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label [msgcat::mc {X Point}] \
	-variable prefs(marker,shape) -value {x point} -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label [msgcat::mc {Arrow Point}] \
	-variable prefs(marker,shape) -value {arrow point} -command SavePrefs
    $ds9(mb).prefs.gui.region.shape add radiobutton \
	-label [msgcat::mc {BoxCircle Point}] \
	-variable prefs(marker,shape) -value {boxcircle point} \
	-command SavePrefs

    menu $ds9(mb).prefs.gui.region.color
    $ds9(mb).prefs.gui.region.color add radiobutton \
	-label [msgcat::mc {Black}] \
	-variable prefs(marker,color) -value black -command SavePrefs
    $ds9(mb).prefs.gui.region.color add radiobutton \
	-label [msgcat::mc {White}] \
	-variable prefs(marker,color) -value white -command SavePrefs
    $ds9(mb).prefs.gui.region.color add radiobutton \
	-label [msgcat::mc {Red}] \
	-variable prefs(marker,color) -value red -command SavePrefs
    $ds9(mb).prefs.gui.region.color add radiobutton \
	-label [msgcat::mc {Green}] \
	-variable prefs(marker,color) -value green -command SavePrefs
    $ds9(mb).prefs.gui.region.color add radiobutton \
	-label [msgcat::mc {Blue}] \
	-variable prefs(marker,color) -value blue -command SavePrefs
    $ds9(mb).prefs.gui.region.color add radiobutton \
	-label [msgcat::mc {Cyan}] \
	-variable prefs(marker,color) -value cyan -command SavePrefs
    $ds9(mb).prefs.gui.region.color add radiobutton \
	-label [msgcat::mc {Magenta}] \
	-variable prefs(marker,color) -value magenta -command SavePrefs
    $ds9(mb).prefs.gui.region.color add radiobutton \
	-label [msgcat::mc {Yellow}] \
	-variable prefs(marker,color) -value yellow -command SavePrefs

    menu $ds9(mb).prefs.gui.region.width
    $ds9(mb).prefs.gui.region.width add radiobutton -label {1} \
	-variable prefs(marker,width) -value 1 -command SavePrefs
    $ds9(mb).prefs.gui.region.width add radiobutton -label {2} \
	-variable prefs(marker,width) -value 2 -command SavePrefs
    $ds9(mb).prefs.gui.region.width add radiobutton -label {3} \
	-variable prefs(marker,width) -value 3 -command SavePrefs
    $ds9(mb).prefs.gui.region.width add radiobutton -label {4} \
	-variable prefs(marker,width) -value 4 -command SavePrefs

    menu $ds9(mb).prefs.gui.region.properties
    $ds9(mb).prefs.gui.region.properties add checkbutton \
	-label [msgcat::mc {Can Edit}] \
	-variable prefs(marker,edit) -command SavePrefs
    $ds9(mb).prefs.gui.region.properties add checkbutton \
	-label [msgcat::mc {Can Move}] \
	-variable prefs(marker,move) -command SavePrefs
    $ds9(mb).prefs.gui.region.properties add checkbutton \
	-label [msgcat::mc {Can Rotate}] \
	-variable prefs(marker,rotate) -command SavePrefs
    $ds9(mb).prefs.gui.region.properties add checkbutton \
	-label [msgcat::mc {Can Delete}] \
	-variable prefs(marker,delete) -command SavePrefs
    $ds9(mb).prefs.gui.region.properties add checkbutton \
	-label [msgcat::mc {Fixed in Size}] \
	-variable prefs(marker,fixed) -command SavePrefs

    $ds9(mb).prefs.gui.region.properties add separator
    $ds9(mb).prefs.gui.region.properties add radiobutton \
	-label [msgcat::mc {Include}] \
	-variable prefs(marker,include) -value 1 -command SavePrefs
    $ds9(mb).prefs.gui.region.properties add radiobutton \
	-label [msgcat::mc {Exclude}] \
	-variable prefs(marker,include) -value 0 -command SavePrefs
    $ds9(mb).prefs.gui.region.properties add separator
    $ds9(mb).prefs.gui.region.properties add radiobutton \
	-label [msgcat::mc {Source}] \
	-variable prefs(marker,source) -value 1 -command SavePrefs
    $ds9(mb).prefs.gui.region.properties add radiobutton \
	-label [msgcat::mc {Background}] \
	-variable prefs(marker,source) -value 0 -command SavePrefs

    menu $ds9(mb).prefs.gui.region.font
    $ds9(mb).prefs.gui.region.font add radiobutton \
	-label [msgcat::mc {Times}] \
	-variable prefs(marker,font) -value times -command SavePrefs
    $ds9(mb).prefs.gui.region.font add radiobutton \
	-label [msgcat::mc {Helvetica}] \
	-variable prefs(marker,font) -value helvetica -command SavePrefs
    $ds9(mb).prefs.gui.region.font add radiobutton \
	-label [msgcat::mc {Symbol}] \
	-variable prefs(marker,font) -value symbol -command SavePrefs
    $ds9(mb).prefs.gui.region.font add radiobutton \
	-label [msgcat::mc {Courier}] \
	-variable prefs(marker,font) -value courier -command SavePrefs
    $ds9(mb).prefs.gui.region.font add separator
    $ds9(mb).prefs.gui.region.font add radiobutton -label {9} \
	-variable prefs(marker,font,size) -value 9 -command SavePrefs
    $ds9(mb).prefs.gui.region.font add radiobutton -label {10} \
	-variable prefs(marker,font,size) -value 10 -command SavePrefs
    $ds9(mb).prefs.gui.region.font add radiobutton -label {12} \
	-variable prefs(marker,font,size) -value 12 -command SavePrefs
    $ds9(mb).prefs.gui.region.font add radiobutton -label {14} \
	-variable prefs(marker,font,size) -value 14 -command SavePrefs
    $ds9(mb).prefs.gui.region.font add radiobutton -label {18} \
	-variable prefs(marker,font,size) -value 18 -command SavePrefs
    $ds9(mb).prefs.gui.region.font add radiobutton -label {24} \
	-variable prefs(marker,font,size) -value 24 -command SavePrefs
    $ds9(mb).prefs.gui.region.font add radiobutton -label {30} \
	-variable prefs(marker,font,size) -value 30 -command SavePrefs
    $ds9(mb).prefs.gui.region.font add radiobutton -label {36} \
	-variable prefs(marker,font,size) -value 36 -command SavePrefs
    $ds9(mb).prefs.gui.region.font add radiobutton -label {72} \
	-variable prefs(marker,font,size) -value 72 -command SavePrefs
    $ds9(mb).prefs.gui.region.font add separator
    $ds9(mb).prefs.gui.region.font add radiobutton \
	-label [msgcat::mc {Plain}] \
	-variable prefs(marker,font,style) -value normal -command SavePrefs
    $ds9(mb).prefs.gui.region.font add radiobutton \
	-label [msgcat::mc {Bold}] \
	-variable prefs(marker,font,style) -value bold -command SavePrefs
    $ds9(mb).prefs.gui.region.font add radiobutton \
	-label [msgcat::mc {Italic}] \
	-variable prefs(marker,font,style) -value italic -command SavePrefs

    menu $ds9(mb).prefs.gui.region.format
    $ds9(mb).prefs.gui.region.format add radiobutton -label {DS9/Funtools} \
	-variable prefs(marker,format) -value ds9 -command PrefsMarkerFormat
    $ds9(mb).prefs.gui.region.format add radiobutton -label {Ciao} \
	-variable prefs(marker,format) -value ciao -command PrefsMarkerFormat
    $ds9(mb).prefs.gui.region.format add radiobutton -label {SAOtng} \
	-variable prefs(marker,format) -value saotng -command PrefsMarkerFormat
    $ds9(mb).prefs.gui.region.format add radiobutton -label {SAOimage} \
	-variable prefs(marker,format) -value saoimage \
	-command PrefsMarkerFormat
    $ds9(mb).prefs.gui.region.format add radiobutton -label {IRAF PROS} \
	-variable prefs(marker,format) -value pros -command PrefsMarkerFormat
    $ds9(mb).prefs.gui.region.format add radiobutton -label {X Y} \
	-variable prefs(marker,format) -value xy -command PrefsMarkerFormat
    $ds9(mb).prefs.gui.region.format add separator
    $ds9(mb).prefs.gui.region.format add checkbutton \
	-label [msgcat::mc {Strip Output}] -variable prefs(marker,strip)
    $ds9(mb).prefs.gui.region.format add checkbutton \
	-label [msgcat::mc {List WCS}] -variable prefs(marker,wcs)

    menu $ds9(mb).prefs.gui.region.coord
    $ds9(mb).prefs.gui.region.coord add radiobutton -label [msgcat::mc {WCS}] \
	-variable prefs(marker,system) -value wcs -command SavePrefs
    $ds9(mb).prefs.gui.region.coord add cascade \
	-label [msgcat::mc {Multiple WCS}] \
	-menu $ds9(mb).prefs.gui.region.coord.wcs
    $ds9(mb).prefs.gui.region.coord add separator
    $ds9(mb).prefs.gui.region.coord add radiobutton \
	-label [msgcat::mc {Image}] \
	-variable prefs(marker,system) -value image -command SavePrefs
    $ds9(mb).prefs.gui.region.coord add radiobutton \
	-label [msgcat::mc {Physical}] \
	-variable prefs(marker,system) -value physical -command SavePrefs
    $ds9(mb).prefs.gui.region.coord add radiobutton \
	-label [msgcat::mc {Amplifier}] \
	-variable prefs(marker,system) -value amplifier -command SavePrefs
    $ds9(mb).prefs.gui.region.coord add radiobutton \
	-label [msgcat::mc {Detector}] \
	-variable prefs(marker,system) -value detector -command SavePrefs
    $ds9(mb).prefs.gui.region.coord add separator
    $ds9(mb).prefs.gui.region.coord add radiobutton \
	-label "[msgcat::mc {Equatorial}] B1950" \
	-variable prefs(marker,sky) -value fk4 -command SavePrefs
    $ds9(mb).prefs.gui.region.coord add radiobutton \
	-label "[msgcat::mc {Equatorial}] J2000" \
	-variable prefs(marker,sky) -value fk5 -command SavePrefs
    $ds9(mb).prefs.gui.region.coord add radiobutton \
	-label [msgcat::mc {ICRS}] \
	-variable prefs(marker,sky) -value icrs -command SavePrefs
    $ds9(mb).prefs.gui.region.coord add radiobutton \
	-label [msgcat::mc {Galactic}] \
	-variable prefs(marker,sky) -value galactic -command SavePrefs
    $ds9(mb).prefs.gui.region.coord add radiobutton \
	-label [msgcat::mc {Ecliptic}] \
	-variable prefs(marker,sky) -value ecliptic -command SavePrefs
    $ds9(mb).prefs.gui.region.coord add separator
    $ds9(mb).prefs.gui.region.coord add radiobutton \
	-label [msgcat::mc {Degrees}] \
	-variable prefs(marker,skyformat) -value degrees -command SavePrefs
    $ds9(mb).prefs.gui.region.coord add radiobutton -label {Sexagesimal} \
	-variable prefs(marker,skyformat) -value sexagesimal -command SavePrefs

    menu $ds9(mb).prefs.gui.region.coord.wcs
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$ds9(mb).prefs.gui.region.coord.wcs add radiobutton \
	    -label "[msgcat::mc {WCS}] $l" \
	    -variable prefs(marker,system) -value "wcs$l" -command SavePrefs
    }

    menu $ds9(mb).prefs.gui.region.dialog
    $ds9(mb).prefs.gui.region.dialog add cascade \
	-label [msgcat::mc {Coordinate System}] \
	-menu $ds9(mb).prefs.gui.region.dialog.sys
    $ds9(mb).prefs.gui.region.dialog add cascade \
	-label [msgcat::mc {Distance System}] \
	-menu $ds9(mb).prefs.gui.region.dialog.dist

    menu $ds9(mb).prefs.gui.region.dialog.sys
    $ds9(mb).prefs.gui.region.dialog.sys add radiobutton \
	-label [msgcat::mc {WCS}] \
	-variable marker(dialog,system) -value wcs -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.sys add cascade \
	-label [msgcat::mc {Multiple WCS}] \
	-menu $ds9(mb).prefs.gui.region.dialog.sys.wcs
    $ds9(mb).prefs.gui.region.dialog.sys add separator
    $ds9(mb).prefs.gui.region.dialog.sys add radiobutton \
	-label [msgcat::mc {Image}] \
	-variable marker(dialog,system) -value image -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.sys add radiobutton \
	-label [msgcat::mc {Physical}] \
	-variable marker(dialog,system) -value physical -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.sys add radiobutton \
	-label [msgcat::mc {Amplifier}] \
	-variable marker(dialog,system) -value amplifier -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.sys add radiobutton \
	-label [msgcat::mc {Detector}] \
	-variable marker(dialog,system) -value detector -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.sys add separator
    $ds9(mb).prefs.gui.region.dialog.sys add radiobutton \
	-label "[msgcat::mc {Equatorial}] B1950" \
	-variable marker(dialog,sky) -value fk4 -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.sys add radiobutton \
	-label "[msgcat::mc {Equatorial}] J2000" \
	-variable marker(dialog,sky) -value fk5 -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.sys add radiobutton \
	-label [msgcat::mc {ICRS}] \
	-variable marker(dialog,sky) -value icrs -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.sys add radiobutton \
	-label [msgcat::mc {Galactic}] \
	-variable marker(dialog,sky) -value galactic -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.sys add radiobutton \
	-label [msgcat::mc {Ecliptic}] \
	-variable marker(dialog,sky) -value ecliptic -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.sys add separator
    $ds9(mb).prefs.gui.region.dialog.sys add radiobutton \
	-label [msgcat::mc {Degrees}] \
	-variable marker(dialog,skyformat) -value degrees -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.sys add radiobutton \
	-label {Sexagesimal} \
	-variable marker(dialog,skyformat) -value sexagesimal \
	-command SavePrefs

    menu $ds9(mb).prefs.gui.region.dialog.sys.wcs
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$ds9(mb).prefs.gui.region.dialog.sys.wcs add radiobutton \
	    -label "[msgcat::mc {WCS}] $l" \
	    -variable marker(dialog,system) -value "wcs$l" -command SavePrefs
    }

    menu $ds9(mb).prefs.gui.region.dialog.dist
    $ds9(mb).prefs.gui.region.dialog.dist add radiobutton \
	-label [msgcat::mc {WCS}] \
	-variable marker(dialog,dist,system) -value wcs -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.dist add cascade \
	-label [msgcat::mc {Multiple WCS}] \
	-menu $ds9(mb).prefs.gui.region.dialog.dist.wcs
    $ds9(mb).prefs.gui.region.dialog.dist add separator
    $ds9(mb).prefs.gui.region.dialog.dist add radiobutton \
	-label [msgcat::mc {Image}] \
	-variable marker(dialog,dist,system) -value image -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.dist add radiobutton \
	-label [msgcat::mc {Physical}] \
	-variable marker(dialog,dist,system) -value physical -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.dist add radiobutton \
	-label [msgcat::mc {Amplifier}] \
	-variable marker(dialog,dist,system) -value amplifier \
	-command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.dist add radiobutton \
	-label [msgcat::mc {Detector}] \
	-variable marker(dialog,dist,system) -value detector -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.dist add separator
    $ds9(mb).prefs.gui.region.dialog.dist add radiobutton \
	-label [msgcat::mc {Degrees}] \
	-variable marker(dialog,dist,format) -value degrees -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.dist add radiobutton \
	-label [msgcat::mc {ArcMin}] \
	-variable marker(dialog,dist,format) -value arcmin -command SavePrefs
    $ds9(mb).prefs.gui.region.dialog.dist add radiobutton \
	-label [msgcat::mc {ArcSec}] \
	-variable marker(dialog,dist,format) -value arcsec -command SavePrefs

    menu $ds9(mb).prefs.gui.region.dialog.dist.wcs
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$ds9(mb).prefs.gui.region.dialog.dist.wcs add radiobutton \
	    -label "[msgcat::mc {WCS}] $l" \
	    -variable marker(dialog,dist,system) -value "wcs$l" \
	    -command SavePrefs
    }
}

proc RegionButtons {} {
    global ds9

    frame $ds9(buttons).region1
    ButtonButton $ds9(buttons).region1.info \
	[string tolower [msgcat::mc {Information}]] MarkerInfo
    ButtonButton $ds9(buttons).region1.front \
	[string tolower [msgcat::mc {Front}]] MarkerFront
    ButtonButton $ds9(buttons).region1.back \
	[string tolower [msgcat::mc {Back}]]	MarkerBack
    ButtonButton $ds9(buttons).region1.all \
	[string tolower [msgcat::mc {All}]] MarkerSelectAll
    ButtonButton $ds9(buttons).region1.none \
	[string tolower [msgcat::mc {None}]] \
	MarkerUnselectAll
    ButtonButton $ds9(buttons).region1.invert \
	[string tolower [msgcat::mc {Invert}]] \
	MarkerSelectInvert
    ButtonButton $ds9(buttons).region1.delete \
	[string tolower [msgcat::mc {Delete}]] \
	MarkerDeleteSelect
    ButtonButton $ds9(buttons).region1.deleteall \
	[string tolower [msgcat::mc {Delete All}]] \
	MarkerDeleteAllMenu
    ButtonButton $ds9(buttons).region1.list \
	[string tolower [msgcat::mc {List}]] MarkerDisplay
    ButtonButton $ds9(buttons).region1.load \
	[string tolower [msgcat::mc {Load}]]	MarkerOpen
    ButtonButton $ds9(buttons).region1.save \
	[string tolower [msgcat::mc {Save}]]	MarkerSave
    RadioButton $ds9(buttons).region1.more \
	[string tolower [msgcat::mc {More}]] \
	buttons(majorCurrent) $ds9(buttons).region2 MajorButton
    
    frame $ds9(buttons).region2
    RadioButton $ds9(buttons).region2.circle \
	[string tolower [msgcat::mc {Circle}]] \
	marker(shape) circle {}
    RadioButton $ds9(buttons).region2.ellipse \
	[string tolower [msgcat::mc {Ellipse}]] \
	marker(shape) ellipse {}
    RadioButton $ds9(buttons).region2.box \
	[string tolower [msgcat::mc {Box}]] \
	marker(shape) box {}
    RadioButton $ds9(buttons).region2.polygon \
	[string tolower [msgcat::mc {Polygon}]] \
	marker(shape) polygon {}
    RadioButton $ds9(buttons).region2.line \
	[string tolower [msgcat::mc {Line}]] \
	marker(shape) line {}
    RadioButton $ds9(buttons).region2.vector \
	[string tolower [msgcat::mc {Vector}]] \
	marker(shape) vector {}
    RadioButton $ds9(buttons).region2.text \
	[string tolower [msgcat::mc {Text}]] \
	marker(shape) text {}
    RadioButton $ds9(buttons).region2.ruler \
	[string tolower [msgcat::mc {Ruler}]] \
	marker(shape) ruler {}
    RadioButton $ds9(buttons).region2.compass \
	[string tolower [msgcat::mc {Compass}]] \
	marker(shape) compass {}
    RadioButton $ds9(buttons).region2.projection \
	[string tolower [msgcat::mc {Projection}]] \
	marker(shape) projection {}
    RadioButton $ds9(buttons).region2.point \
	[string tolower [msgcat::mc {Point}]] \
	marker(shape) {circle point} {}
    RadioButton $ds9(buttons).region2.more \
	[string tolower [msgcat::mc {More}]] \
	buttons(majorCurrent) $ds9(buttons).region3 MajorButton

    frame $ds9(buttons).region3
    RadioButton $ds9(buttons).region3.annulus \
	[string tolower [msgcat::mc {Annulus}]] \
	marker(shape) annulus {}
    RadioButton $ds9(buttons).region3.ellispsannulus \
	[string tolower [msgcat::mc {Elliptical Annulus}]] \
	marker(shape) ellipseannulus {}
    RadioButton $ds9(buttons).region3.boxannulus \
	[string tolower [msgcat::mc {Box Annulus}]] \
	marker(shape) boxannulus {}
    RadioButton $ds9(buttons).region3.panda \
	[string tolower [msgcat::mc {Panda}]] \
	marker(shape) panda {}
    RadioButton $ds9(buttons).region3.epanda \
	[string tolower [msgcat::mc {Ellipse Panda}]] \
	marker(shape) epanda {}
    RadioButton $ds9(buttons).region3.bpanda \
	[string tolower [msgcat::mc {Box Panda}]] \
	marker(shape) bpanda {}
    RadioButton $ds9(buttons).region3.more \
	[string tolower [msgcat::mc {More}]] \
	buttons(majorCurrent) $ds9(buttons).region4 MajorButton

    frame $ds9(buttons).region4
    RadioButton $ds9(buttons).region4.ds9 {ds9}	marker(format) ds9 {}
    RadioButton $ds9(buttons).region4.ciao {ciao} marker(format) ciao {}
    RadioButton $ds9(buttons).region4.saotng {saotng} marker(format) saotng {}
    RadioButton $ds9(buttons).region4.saoimage {saoimage} \
	marker(format) saoimage {}
    RadioButton $ds9(buttons).region4.pros {pros} marker(format) pros {}
    RadioButton $ds9(buttons).region4.xy {xy} marker(format) xy {}
    RadioButton $ds9(buttons).region4.more \
	[string tolower [msgcat::mc {More}]] \
	buttons(majorCurrent) $ds9(buttons).region5 MajorButton

    frame $ds9(buttons).region5
    RadioButton $ds9(buttons).region5.image \
	[string tolower [msgcat::mc {Image}]] \
	marker(system) image {}
    RadioButton $ds9(buttons).region5.physical \
	[string tolower [msgcat::mc {Physical}]] \
	marker(system) physical {}
    RadioButton $ds9(buttons).region5.wcs \
	[string tolower [msgcat::mc {WCS}]] \
	marker(system) wcs {}
    RadioButton $ds9(buttons).region5.fk4 {fk4} \
	marker(sky) fk4 {}
    RadioButton $ds9(buttons).region5.fk5 {fk5} \
	marker(sky) fk5 {}
    RadioButton $ds9(buttons).region5.icrs \
	[string tolower [msgcat::mc {ICRS}]] \
	marker(sky) icrs {}
    RadioButton $ds9(buttons).region5.galactic \
	[string tolower [msgcat::mc {Galactic}]] \
	marker(sky) galactic {}
    RadioButton $ds9(buttons).region5.ecliptic \
	[string tolower [msgcat::mc {Ecliptic}]] \
	marker(sky) ecliptic {}
    RadioButton $ds9(buttons).region5.deg \
	[string tolower [msgcat::mc {Degrees}]] \
	marker(skyformat) degrees {}
    RadioButton $ds9(buttons).region5.sex {sexagesimal} \
	marker(skyformat) sexagesimal {}
    RadioButton $ds9(buttons).region5.more \
	[string tolower [msgcat::mc {More}]] \
	buttons(majorCurrent) $ds9(buttons).region1 MajorButton
}

proc UpdateRegionMenu {} {
    global ds9
    global current
    global marker

    if {$current(frame) != {}} {
	set marker(show) [$current(frame) get marker show]
	set marker(show,text) [$current(frame) get marker show text]
	set marker(preserve) [$current(frame) get marker preserve]

	switch -- $ds9(mode) {
	    pointer {
		if {[$current(frame) get marker select number] == 1} {
		    set marker(color) [$current(frame) get marker color]
		    set marker(width) [$current(frame) get marker width]
		    set marker(edit) [$current(frame) get marker property edit]
		    set marker(move) [$current(frame) get marker property move]
		    set marker(rotate) \
			[$current(frame) get marker property rotate]
		    set marker(delete) \
			[$current(frame) get marker property delete]
		    set marker(fixed) \
			[$current(frame) get marker property fixed]
		    set marker(include) \
			[$current(frame) get marker property include]
		    set marker(source) \
			[$current(frame) get marker property source]

		    set f [$current(frame) get marker font]

		    set marker(font) [lindex $f 0]
		    set marker(font,size) [lindex $f 1]
		    set marker(font,style) [lindex $f 2]
		}
	    }
	}
    }

    UpdateMarkerFormatMenu
}

