#  Copyright (C) 1999-2007
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc ScaleMenu {} {
    global ds9

    menu $ds9(mb).scale
    $ds9(mb).scale add radiobutton -label [msgcat::mc {Linear}] \
	-variable scale(type) -command ChangeScale -value linear
    $ds9(mb).scale add radiobutton -label [msgcat::mc {Log}] \
	-variable scale(type) -command ChangeScale -value log
    $ds9(mb).scale add radiobutton -label [msgcat::mc {Power}] \
	-variable scale(type) -command ChangeScale -value pow
    $ds9(mb).scale add radiobutton -label [msgcat::mc {Square Root}] \
	-variable scale(type) -command ChangeScale -value sqrt
    $ds9(mb).scale add radiobutton -label [msgcat::mc {Squared}] \
	-variable scale(type) -command ChangeScale -value squared
    $ds9(mb).scale add radiobutton \
	-label [msgcat::mc {Histogram Equalization}] \
	-variable scale(type) -command ChangeScale -value histequ
    $ds9(mb).scale add separator
    $ds9(mb).scale add radiobutton -label [msgcat::mc {Min Max}] \
        -variable scale(mode) -command ChangeScaleMode -value minmax
    $ds9(mb).scale add radiobutton -label {99.5%} \
	-variable scale(mode) -command ChangeScaleMode -value 99.5
    $ds9(mb).scale add radiobutton -label {99%} \
	-variable scale(mode) -command ChangeScaleMode -value 99
    $ds9(mb).scale add radiobutton -label {98%} \
	-variable scale(mode) -command ChangeScaleMode -value 98
    $ds9(mb).scale add radiobutton -label {95%} \
	-variable scale(mode) -command ChangeScaleMode -value 95
    $ds9(mb).scale add radiobutton -label {90%} \
	-variable scale(mode) -command ChangeScaleMode -value 90
    $ds9(mb).scale add radiobutton -label {ZScale} \
	-variable scale(mode) 	-command ChangeScaleMode -value zscale
    $ds9(mb).scale add radiobutton -label {ZMax} \
	-variable scale(mode) -command ChangeScaleMode -value zmax
    $ds9(mb).scale add radiobutton -label [msgcat::mc {User}] \
	-variable scale(mode) -command ChangeScaleMode -value user
    $ds9(mb).scale add separator
    $ds9(mb).scale add cascade -label [msgcat::mc {Scope}] \
	-menu $ds9(mb).scale.scope
    $ds9(mb).scale add cascade -label [msgcat::mc {Min Max}] \
	-menu $ds9(mb).scale.minmax
    $ds9(mb).scale add separator
    $ds9(mb).scale add checkbutton -label "[msgcat::mc {Use}] DATASEC" \
	-variable scale(datasec) -command ChangeDATASEC
    $ds9(mb).scale add separator
    $ds9(mb).scale add command -label "[msgcat::mc {Scale Parameters}]..." \
	-command ScaleDialog

    menu $ds9(mb).scale.scope
    $ds9(mb).scale.scope add radiobutton -label [msgcat::mc {Global}] \
	-variable scale(scope) -command ChangeScaleScope -value global
    $ds9(mb).scale.scope add radiobutton -label [msgcat::mc {Local}] \
	-variable scale(scope) -command ChangeScaleScope -value local

    menu $ds9(mb).scale.minmax
    $ds9(mb).scale.minmax add radiobutton -label [msgcat::mc {Automatic}] \
	-variable minmax(mode) -value auto -command ChangeMinMaxMode
    $ds9(mb).scale.minmax add radiobutton -label [msgcat::mc {Scan}] \
	-variable minmax(mode) -value scan -command ChangeMinMaxMode
    $ds9(mb).scale.minmax add radiobutton -label [msgcat::mc {Sample}] \
	-variable minmax(mode) -value sample -command ChangeMinMaxMode
    $ds9(mb).scale.minmax add radiobutton -label {DATAMIN DATAMAX} \
	-variable minmax(mode) -value datamin -command ChangeMinMaxMode
    $ds9(mb).scale.minmax add radiobutton -label {IRAF-MIN IRAF-MAX} \
	-variable minmax(mode) -value irafmin -command ChangeMinMaxMode
    $ds9(mb).scale.minmax add separator
    $ds9(mb).scale.minmax add command \
	-label "[msgcat::mc {Sample Parameters}]..." \
	-command {MinMaxSampleDialog minmax(sample) 1}

    ScalePrefsMenu
}

proc ScalePrefsMenu {} {
    global ds9
    global prefs

    menu $ds9(mb).prefs.gui.scale
    $ds9(mb).prefs.gui.scale add radiobutton -label [msgcat::mc {Linear}] \
	-variable prefs(scale) -value linear -command SavePrefs
    $ds9(mb).prefs.gui.scale add radiobutton -label [msgcat::mc {Log}] \
	-variable prefs(scale) -value log -command SavePrefs
    $ds9(mb).prefs.gui.scale add radiobutton -label [msgcat::mc {Power}] \
	-variable prefs(scale) -value pow -command SavePrefs
    $ds9(mb).prefs.gui.scale add radiobutton -label [msgcat::mc {Square Root}]\
	-variable prefs(scale) -value sqrt -command SavePrefs
    $ds9(mb).prefs.gui.scale add radiobutton -label [msgcat::mc {Squared}] \
	-variable prefs(scale) -value squared -command SavePrefs
    $ds9(mb).prefs.gui.scale add radiobutton \
	-label [msgcat::mc {Histogram Equalization}] \
	-variable prefs(scale) -value histequ -command SavePrefs
    $ds9(mb).prefs.gui.scale add separator
    $ds9(mb).prefs.gui.scale add radiobutton -label  [msgcat::mc {Min Max}] \
	-variable prefs(scale,mode) -value minmax -command SavePrefs
    $ds9(mb).prefs.gui.scale add radiobutton -label {99.5%} \
	-variable prefs(scale,mode) -value 99.5 -command SavePrefs
    $ds9(mb).prefs.gui.scale add radiobutton -label {99%} \
	-variable prefs(scale,mode) -value 99 -command SavePrefs
    $ds9(mb).prefs.gui.scale add radiobutton -label {98%} \
	-variable prefs(scale,mode) -value 98 -command SavePrefs
    $ds9(mb).prefs.gui.scale add radiobutton -label {95%} \
	-variable prefs(scale,mode) -value 95 -command SavePrefs
    $ds9(mb).prefs.gui.scale add radiobutton -label {90%} \
	-variable prefs(scale,mode) -value 90 -command SavePrefs
    $ds9(mb).prefs.gui.scale add radiobutton -label {ZScale} \
	-variable prefs(scale,mode) -value zscale -command SavePrefs
    $ds9(mb).prefs.gui.scale add radiobutton -label {ZMax} \
	-variable prefs(scale,mode) -value zmax -command SavePrefs
    $ds9(mb).prefs.gui.scale add radiobutton -label [msgcat::mc {User}] \
	-variable prefs(scale,mode) -value user -command SavePrefs
    $ds9(mb).prefs.gui.scale add separator
    $ds9(mb).prefs.gui.scale add cascade -label [msgcat::mc {Scope}] \
	-menu $ds9(mb).prefs.gui.scale.scope
    $ds9(mb).prefs.gui.scale add cascade -label [msgcat::mc {Min Max}] \
	-menu $ds9(mb).prefs.gui.scale.minmax
    $ds9(mb).prefs.gui.scale add separator
    $ds9(mb).prefs.gui.scale add checkbutton \
	-label "[msgcat::mc {Use}] DATASEC" \
	-variable prefs(scale,datasec) -command SavePrefs

    menu $ds9(mb).prefs.gui.scale.scope
    $ds9(mb).prefs.gui.scale.scope add radiobutton \
	-label [msgcat::mc {Global}] \
	-variable prefs(scale,scope) -value global -command SavePrefs
    $ds9(mb).prefs.gui.scale.scope add radiobutton \
	-label [msgcat::mc {Local}] \
	-variable prefs(scale,scope) -value local -command SavePrefs

    menu $ds9(mb).prefs.gui.scale.minmax
    $ds9(mb).prefs.gui.scale.minmax add radiobutton \
	-label [msgcat::mc {Automatic}] \
	-variable prefs(minmax,mode) -value auto -command SavePrefs
    $ds9(mb).prefs.gui.scale.minmax add radiobutton \
	-label [msgcat::mc {Scan}] \
	-variable prefs(minmax,mode) -value scan -command SavePrefs
    $ds9(mb).prefs.gui.scale.minmax add radiobutton \
	-label [msgcat::mc {Sample}] \
	-variable prefs(minmax,mode) -value sample -command SavePrefs
    $ds9(mb).prefs.gui.scale.minmax add radiobutton \
	-label {DATAMIN DATAMAX} \
	-variable prefs(minmax,mode) -value datamin -command SavePrefs
    $ds9(mb).prefs.gui.scale.minmax add radiobutton \
	-label {IRAF-MIN IRAF-MAX} \
	-variable prefs(minmax,mode) -value irafmin -command SavePrefs
    $ds9(mb).prefs.gui.scale.minmax add separator
    $ds9(mb).prefs.gui.scale.minmax add command \
	-label "[msgcat::mc {Sample Parameters}]..." \
	-command {MinMaxSampleDialog prefs(minmax,sample) 0}
}

proc ScaleButtons {} {
    global ds9
    global scale

    frame $ds9(buttons).scale1
    RadioButton $ds9(buttons).scale1.linear \
	[string tolower [msgcat::mc {Linear}]] \
	scale(type) linear ChangeScale
    RadioButton $ds9(buttons).scale1.log \
	[string tolower [msgcat::mc {Log}]] \
	scale(type) log ChangeScale
    RadioButton $ds9(buttons).scale1.pow \
	[string tolower [msgcat::mc {Power}]] \
	scale(type) pow ChangeScale
    RadioButton $ds9(buttons).scale1.sqrt \
	[string tolower [msgcat::mc {Square Root}]] \
	scale(type) sqrt ChangeScale
    RadioButton $ds9(buttons).scale1.squared \
	[string tolower [msgcat::mc {Squared}]] \
	scale(type) squared ChangeScale
    RadioButton $ds9(buttons).scale1.histogram \
	[string tolower [msgcat::mc {Histogram}]] \
	scale(type) histequ ChangeScale
    RadioButton $ds9(buttons).scale1.more \
	[string tolower [msgcat::mc {More}]] \
	buttons(majorCurrent) $ds9(buttons).scale2 MajorButton


    frame $ds9(buttons).scale2
    RadioButton $ds9(buttons).scale2.minmax \
	[string tolower [msgcat::mc {Min Max}]] \
	scale(mode) minmax ChangeScaleMode
    RadioButton $ds9(buttons).scale2.p995 {99.5%} \
	scale(mode) 99.5 ChangeScaleMode
    RadioButton $ds9(buttons).scale2.p99 {99%} \
	scale(mode) 99 ChangeScaleMode
    RadioButton $ds9(buttons).scale2.p98 {98%} \
	scale(mode) 98 ChangeScaleMode
    RadioButton $ds9(buttons).scale2.p95 {95%} \
	scale(mode) 95 ChangeScaleMode
    RadioButton $ds9(buttons).scale2.p90 {90%} \
	scale(mode) 90 ChangeScaleMode
    RadioButton $ds9(buttons).scale2.zscale {zscale} \
	scale(mode) zscale ChangeScaleMode
    RadioButton $ds9(buttons).scale2.zmax {zmax} \
	scale(mode) zmax ChangeScaleMode
    RadioButton $ds9(buttons).scale2.user \
	[string tolower [msgcat::mc {User}]] \
	scale(mode) user ChangeScaleMode
    RadioButton $ds9(buttons).scale2.more \
	[string tolower [msgcat::mc {More}]] \
	buttons(majorCurrent) $ds9(buttons).scale1 MajorButton
}

proc UpdateScaleMenu {} {
    global ds9
    global current
    global scale

    global debug
    if {$debug(tcl,update)} {
	puts "UpdateScaleMenu"
    }

    if {$current(frame) != {}} {
	if {![$current(frame) has iis]} {
	    $ds9(mb) entryconfig [msgcat::mc {Scale}] -state normal
	    $ds9(buttons).major.scale configure -state normal

	    set scale(type) [$current(frame) get colorscale]
	    set scale(scope) [$current(frame) get clip scope]
	    set scale(mode) [$current(frame) get clip mode]
	    set scale(datasec) [$current(frame) get datasec]
	    set scale(preserve) [$current(frame) get clip preserve]
	    set minmax(mode) [$current(frame) get clip minmax mode]
	    set minmax(sample) [$current(frame) get clip minmax sample]

	    if {[$current(frame) has fits]} {
		if {[$current(frame) has fits mosaic] || \
			[$current(frame) has fits cube]} {
		    $ds9(mb).scale entryconfig [msgcat::mc {Scope}] \
			-state normal
		} else {
		    $ds9(mb).scale entryconfig [msgcat::mc {Scope}] \
			-state disabled
		}

		if [$current(frame) has datasec] {
		    $ds9(mb).scale entryconfig "[msgcat::mc {Use}] DATASEC" \
			-state normal
		} else {
		    $ds9(mb).scale entryconfig "[msgcat::mc {Use}] DATASEC" \
			-state disabled
		}

		if [$current(frame) has datamin] {
		    $ds9(mb).scale.minmax \
			entryconfig {DATAMIN DATAMAX} -state normal
		} else {
		    $ds9(mb).scale.minmax \
			entryconfig {DATAMIN DATAMAX} -state disabled
		}

		if [$current(frame) has irafmin] {
		    $ds9(mb).scale.minmax \
			entryconfig {IRAF-MIN IRAF-MAX} -state normal
		} else {
		    $ds9(mb).scale.minmax \
			entryconfig {IRAF-MIN IRAF-MAX} -state disabled
		}
	    } else {
		$ds9(mb).scale entryconfig [msgcat::mc {Scope}] -state normal
		$ds9(mb).scale entryconfig "[msgcat::mc {Use}] DATASEC" \
		    -state normal
		$ds9(mb).scale.minmax entryconfig {DATAMIN DATAMAX} \
		    -state normal
		$ds9(mb).scale.minmax entryconfig {IRAF-MIN IRAF-MAX} \
		    -state normal
	    }

	    return
	}
    }

    # default
    $ds9(mb) entryconfig [msgcat::mc {Scale}] -state disabled
    $ds9(buttons).major.scale configure -state disabled
}

