#  Copyright (C) 1999-2007
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc ViewMenu {} {
    global ds9

    menu $ds9(mb).view
    $ds9(mb).view add radiobutton -label [msgcat::mc {Horizontal Layout}] \
	-variable view(layout) -value horizontal  \
	-command {LayoutViewReset; UpdateView}
    $ds9(mb).view add radiobutton -label [msgcat::mc {Vertical Layout}] \
	-variable view(layout) -value vertical  \
	-command {LayoutViewReset; UpdateView}
    $ds9(mb).view add separator
    $ds9(mb).view add checkbutton -label [msgcat::mc {Information Panel}] \
	-variable view(info) -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {Panner}] \
	-variable view(panner) -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {Magnifier}] \
	-variable view(magnifier) -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {Buttons}] \
	-variable view(buttons) -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {Colorbar}] \
	-variable view(colorbar) -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {Horizontal Graph}] \
	-variable view(graph,horz) -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {Vertical Graph}] \
	-variable view(graph,vert) -command UpdateView
    $ds9(mb).view add separator
    $ds9(mb).view add checkbutton -label [msgcat::mc {Filename}] \
	-variable view(info,filename) -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {Object}] \
	-variable view(info,object) -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {Min Max}] \
	-variable view(info,minmax) -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {Low High}] \
	-variable view(info,lowhigh) -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {Frame Information}] \
	-variable view(info,frame) -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {WCS}] \
	-variable view(info,wcs) -command UpdateView
    $ds9(mb).view add cascade -label [msgcat::mc {Multiple WCS}] \
	-menu $ds9(mb).view.wcs -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {Image}] \
	-variable view(info,image) -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {Physical}] \
	-variable view(info,physical) -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {Amplifier}] \
	-variable view(info,amplifier) -command UpdateView
    $ds9(mb).view add checkbutton -label [msgcat::mc {Detector}] \
	-variable view(info,detector) -command UpdateView
    $ds9(mb).view add separator
    $ds9(mb).view add checkbutton -label [msgcat::mc {Colorbar Numerics}] \
	-variable view(colorbar,numerics) -command UpdateView

    # View Info Panel WCS Prefs
    menu $ds9(mb).view.wcs
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$ds9(mb).view.wcs add checkbutton \
	    -label "[msgcat::mc {WCS}] $l" \
	    -variable "view(info,wcs$l)" \
	    -command UpdateView
    }

    ViewPrefsMenu
}

proc ViewPrefsMenu {} {
    global ds9
    global prefs

    menu $ds9(mb).prefs.gui.view
    $ds9(mb).prefs.gui.view add radiobutton \
	-label [msgcat::mc {Horizontal Layout}] \
	-variable prefs(view,layout) -value horizontal -command SavePrefs
    $ds9(mb).prefs.gui.view add radiobutton \
	-label [msgcat::mc {Vertical Layout}] \
	-variable prefs(view,layout) -value vertical -command SavePrefs
    $ds9(mb).prefs.gui.view add separator
    $ds9(mb).prefs.gui.view add checkbutton \
	-label [msgcat::mc {Information Panel}] \
	-variable prefs(view,info) -command SavePrefs
    $ds9(mb).prefs.gui.view add checkbutton -label [msgcat::mc {Panner}] \
	-variable prefs(view,panner) -command SavePrefs
    $ds9(mb).prefs.gui.view add checkbutton -label [msgcat::mc {Magnifier}] \
	-variable prefs(view,magnifier) -command SavePrefs
    $ds9(mb).prefs.gui.view add checkbutton -label [msgcat::mc {Buttons}] \
	-variable prefs(view,buttons) -command SavePrefs
    $ds9(mb).prefs.gui.view add checkbutton -label [msgcat::mc {Colorbar}] \
	-variable prefs(view,colorbar) -command SavePrefs
    $ds9(mb).prefs.gui.view add checkbutton \
	-label [msgcat::mc {Horizontal Graph}] \
	-variable prefs(view,graph,horz) -command SavePrefs
    $ds9(mb).prefs.gui.view add checkbutton \
	-label [msgcat::mc {Vertical Graph}] \
	-variable prefs(view,graph,vert) -command SavePrefs
    $ds9(mb).prefs.gui.view add separator
    $ds9(mb).prefs.gui.view add checkbutton -label [msgcat::mc {Filename}] \
	-variable prefs(view,info,filename) -command SavePrefs
    $ds9(mb).prefs.gui.view add checkbutton -label [msgcat::mc {Object}] \
	-variable prefs(view,info,object) -command SavePrefs
    $ds9(mb).prefs.gui.view add checkbutton -label [msgcat::mc {Min Max}] \
	-variable prefs(view,info,minmax) -command SavePrefs
    $ds9(mb).prefs.gui.view add checkbutton -label [msgcat::mc {Low High}] \
	-variable prefs(view,info,lowhigh) -command SavePrefs
    $ds9(mb).prefs.gui.view add checkbutton -label  [msgcat::mc {Frame Information}]\
	-variable prefs(view,info,frame) -command SavePrefs
    $ds9(mb).prefs.gui.view add checkbutton -label [msgcat::mc {WCS}] \
	-variable prefs(view,info,wcs) -command SavePrefs
    $ds9(mb).prefs.gui.view add cascade -label [msgcat::mc {Multiple WCS}] \
	-menu $ds9(mb).prefs.gui.view.wcs
    $ds9(mb).prefs.gui.view add checkbutton -label [msgcat::mc {Image}] \
	-variable prefs(view,info,image) -command SavePrefs
    $ds9(mb).prefs.gui.view add checkbutton -label [msgcat::mc {Physical}] \
	-variable prefs(view,info,physical) -command SavePrefs
    $ds9(mb).prefs.gui.view add checkbutton -label [msgcat::mc {Amplifier}] \
	-variable prefs(view,info,amplifier) -command SavePrefs
    $ds9(mb).prefs.gui.view add checkbutton -label [msgcat::mc {Detector}] \
	-variable prefs(view,info,detector) -command SavePrefs
    $ds9(mb).prefs.gui.view add separator
    $ds9(mb).prefs.gui.view add checkbutton \
	-label [msgcat::mc {Colorbar Numerics}] \
	-variable prefs(view,colorbar,numerics) -command SavePrefs

    # View WCS Prefs
    menu $ds9(mb).prefs.gui.view.wcs
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$ds9(mb).prefs.gui.view.wcs add checkbutton \
	    -label "[msgcat::mc {WCS}] $l" \
	    -variable "prefs(view,info,wcs$l)" -command SavePrefs
    }
}

proc ViewButtons {} {
    global ds9
    global view

    frame $ds9(buttons).view
    CheckButton $ds9(buttons).view.info \
	[string tolower [msgcat::mc {Information Panel}]] \
	view(info) UpdateView
    CheckButton $ds9(buttons).view.panner \
	[string tolower [msgcat::mc {Panner}]] \
	view(panner) UpdateView
    CheckButton $ds9(buttons).view.magnifier \
	[string tolower [msgcat::mc {Magnifier}]] \
	view(magnifier) UpdateView
    CheckButton $ds9(buttons).view.buttons \
	[string tolower [msgcat::mc {Buttons}]] \
	view(buttons) UpdateView
    CheckButton $ds9(buttons).view.colorbar \
	[string tolower [msgcat::mc {Colorbar}]] \
	view(colorbar) UpdateView
    CheckButton $ds9(buttons).view.graphhorz \
	[string tolower [msgcat::mc {Horizontal Graph}]] \
	view(graph,horz) UpdateView
    CheckButton $ds9(buttons).view.graphvert \
	[string tolower [msgcat::mc {Vertical Graph}]] \
	view(graph,vert) UpdateView
}

