#  Copyright (C) 1999-2007
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc WCSMenu {} {
    global ds9

    menu $ds9(mb).wcs
    $ds9(mb).wcs add radiobutton -label [msgcat::mc {WCS}] \
	-variable wcs(system) -value wcs -command UpdateWCS
    $ds9(mb).wcs add cascade -label [msgcat::mc {Multiple WCS}] \
	-menu $ds9(mb).wcs.wcs
    $ds9(mb).wcs add separator
    $ds9(mb).wcs add radiobutton -label "[msgcat::mc {Equatorial}] B1950" \
	-variable wcs(sky) -value fk4 -command UpdateWCS
    $ds9(mb).wcs add radiobutton -label "[msgcat::mc {Equatorial}] J2000" \
	-variable wcs(sky) -value fk5 -command UpdateWCS
    $ds9(mb).wcs add radiobutton -label [msgcat::mc {ICRS}] \
	-variable wcs(sky) -value icrs -command UpdateWCS
    $ds9(mb).wcs add radiobutton -label [msgcat::mc {Galactic}] \
	-variable wcs(sky) -value galactic -command UpdateWCS
    $ds9(mb).wcs add radiobutton -label [msgcat::mc {Ecliptic}] \
	-variable wcs(sky) -value ecliptic -command UpdateWCS
    $ds9(mb).wcs add separator
    $ds9(mb).wcs add radiobutton -label [msgcat::mc {Degrees}] \
	-variable wcs(skyformat) -value degrees -command UpdateWCS
    $ds9(mb).wcs add radiobutton -label {Sexagesimal} \
	-variable wcs(skyformat) -value sexagesimal -command UpdateWCS

    menu $ds9(mb).wcs.wcs
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$ds9(mb).wcs.wcs add radiobutton \
	    -label "[msgcat::mc {WCS}] $l" \
	    -variable wcs(system) -value "wcs$l" -command UpdateWCS
    }

    WCSPrefsMenu
}

proc WCSPrefsMenu {} {
    global ds9
    global prefs

    menu $ds9(mb).prefs.gui.wcs
    $ds9(mb).prefs.gui.wcs add radiobutton -label [msgcat::mc {WCS}] \
	-variable prefs(wcs,system) -value wcs -command SavePrefs
    $ds9(mb).prefs.gui.wcs add cascade -label [msgcat::mc {Multiple WCS}] \
	-menu $ds9(mb).prefs.gui.wcs.wcs
    $ds9(mb).prefs.gui.wcs add separator
    $ds9(mb).prefs.gui.wcs add radiobutton \
	-label "[msgcat::mc {Equatorial}] B1950" \
	-variable prefs(wcs,sky) -value fk4 -command SavePrefs
    $ds9(mb).prefs.gui.wcs add radiobutton \
	-label "[msgcat::mc {Equatorial}] J2000" \
	-variable prefs(wcs,sky) -value fk5 -command SavePrefs
    $ds9(mb).prefs.gui.wcs add radiobutton -label [msgcat::mc {ICRS}] \
	-variable prefs(wcs,sky) -value icrs -command SavePrefs
    $ds9(mb).prefs.gui.wcs add radiobutton -label [msgcat::mc {Galactic}] \
	-variable prefs(wcs,sky) -value galactic -command SavePrefs
    $ds9(mb).prefs.gui.wcs add radiobutton -label [msgcat::mc {Ecliptic}] \
	-variable prefs(wcs,sky) -value ecliptic -command SavePrefs
    $ds9(mb).prefs.gui.wcs add separator
    $ds9(mb).prefs.gui.wcs add radiobutton -label [msgcat::mc {Degrees}] \
	-variable prefs(wcs,skyformat) -value degrees -command SavePrefs
    $ds9(mb).prefs.gui.wcs add radiobutton -label {Sexagesimal} \
	-variable prefs(wcs,skyformat) -value sexagesimal -command SavePrefs

    menu $ds9(mb).prefs.gui.wcs.wcs
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$ds9(mb).prefs.gui.wcs.wcs add radiobutton \
	    -label "[msgcat::mc {WCS}] $l" \
	    -variable prefs(wcs,system) -value "wcs$l" -command SavePrefs
    }
}

proc WCSButtons {} {
    global ds9
    global wcs

    frame $ds9(buttons).wcs1
    RadioButton $ds9(buttons).wcs1.fk4 {fk4} \
	wcs(sky) fk4 UpdateWCS
    RadioButton $ds9(buttons).wcs1.fk5 {fk5} \
	wcs(sky) fk5 UpdateWCS
    RadioButton $ds9(buttons).wcs1.icrs \
	[string tolower [msgcat::mc {ICRS}]] \
	wcs(sky) icrs UpdateWCS
    RadioButton $ds9(buttons).wcs1.galactic \
	[string tolower [msgcat::mc {Galactic}]] \
	wcs(sky) galactic UpdateWCS
    RadioButton $ds9(buttons).wcs1.ecliptic \
	[string tolower [msgcat::mc {Ecliptic}]] \
	wcs(sky) ecliptic UpdateWCS
    RadioButton $ds9(buttons).wcs1.degrees \
	[string tolower [msgcat::mc {Degrees}]] \
	wcs(skyformat) degrees UpdateWCS
    RadioButton $ds9(buttons).wcs1.sexagesimal {sexagesimal} \
	wcs(skyformat) sexagesimal UpdateWCS
    RadioButton $ds9(buttons).wcs1.more \
	[string tolower [msgcat::mc {More}]] \
	buttons(majorCurrent) $ds9(buttons).wcs2 MajorButton

    frame $ds9(buttons).wcs2
    RadioButton $ds9(buttons).wcs2.wcs wcs wcs(system) wcs UpdateWCS
    RadioButton $ds9(buttons).wcs2.wcsa wcsa wcs(system) wcsa UpdateWCS
    RadioButton $ds9(buttons).wcs2.wcsb wcsb wcs(system) wcsb UpdateWCS
    RadioButton $ds9(buttons).wcs2.wcsc wcsc wcs(system) wcsc UpdateWCS
    RadioButton $ds9(buttons).wcs2.wcsd wcsd wcs(system) wcsd UpdateWCS
    RadioButton $ds9(buttons).wcs2.wcse wcse wcs(system) wcse UpdateWCS
    RadioButton $ds9(buttons).wcs2.wcsf wcsf wcs(system) wcsf UpdateWCS
    RadioButton $ds9(buttons).wcs2.wcsg wcsg wcs(system) wcsg UpdateWCS
    RadioButton $ds9(buttons).wcs2.wcsh wcsh wcs(system) wcsh UpdateWCS
    RadioButton $ds9(buttons).wcs2.wcsi wcsi wcs(system) wcsi UpdateWCS
    RadioButton $ds9(buttons).wcs2.more \
	[string tolower [msgcat::mc {More}]] \
	buttons(majorCurrent) $ds9(buttons).wcs3 MajorButton

    frame $ds9(buttons).wcs3
    RadioButton $ds9(buttons).wcs3.wcsj wcsj wcs(system) wcsj UpdateWCS
    RadioButton $ds9(buttons).wcs3.wcsk wcsk wcs(system) wcsk UpdateWCS
    RadioButton $ds9(buttons).wcs3.wcsl wcsl wcs(system) wcsl UpdateWCS
    RadioButton $ds9(buttons).wcs3.wcsm wcsm wcs(system) wcsm UpdateWCS
    RadioButton $ds9(buttons).wcs3.wcsn wcsn wcs(system) wcsn UpdateWCS
    RadioButton $ds9(buttons).wcs3.wcso wcso wcs(system) wcso UpdateWCS
    RadioButton $ds9(buttons).wcs3.wcsp wcsp wcs(system) wcsp UpdateWCS
    RadioButton $ds9(buttons).wcs3.wcsq wcsq wcs(system) wcsq UpdateWCS
    RadioButton $ds9(buttons).wcs3.wcsr wcsr wcs(system) wcsr UpdateWCS
    RadioButton $ds9(buttons).wcs3.wcss wcss wcs(system) wcss UpdateWCS
    RadioButton $ds9(buttons).wcs3.more \
	[string tolower [msgcat::mc {More}]] \
	buttons(majorCurrent) $ds9(buttons).wcs4 MajorButton

    frame $ds9(buttons).wcs4
    RadioButton $ds9(buttons).wcs4.wcst wcst wcs(system) wcst UpdateWCS
    RadioButton $ds9(buttons).wcs4.wcsu wcsu wcs(system) wcsu UpdateWCS
    RadioButton $ds9(buttons).wcs4.wcsv wcsv wcs(system) wcsv UpdateWCS
    RadioButton $ds9(buttons).wcs4.wcsw wcsw wcs(system) wcsw UpdateWCS
    RadioButton $ds9(buttons).wcs4.wcsx wcsx wcs(system) wcsx UpdateWCS
    RadioButton $ds9(buttons).wcs4.wcsy wcsy wcs(system) wcsy UpdateWCS
    RadioButton $ds9(buttons).wcs4.wcsz wcsz wcs(system) wcsz UpdateWCS
    RadioButton $ds9(buttons).wcs4.more \
	[string tolower [msgcat::mc {More}]] \
	buttons(majorCurrent) $ds9(buttons).wcs1 MajorButton
}

proc UpdateWCSMenu {} {
    global ds9
    global current
    global wcs

    global debug
    if {$debug(tcl,update)} {
	puts "UpdateWCSMenu"
    }

    # check for valid values 
    # bad, can't let wcs(system) change to non wcs value
    # AdjustCoord $current(frame) wcs(system)

    if {$current(frame) != {}} {
	$ds9(mb) entryconfig [msgcat::mc {WCS}] -state normal
	$ds9(buttons).major.wcs1 configure -state normal

	UpdateWCSCoordMenu "$current(frame)" $ds9(mb).wcs

    } else {
	$ds9(mb) entryconfig [msgcat::mc {WCS}] -state disabled
	$ds9(buttons).major.wcs1 configure -state disabled
    }
}

# full WCS coordinate menu
proc UpdateWCSCoordMenu {frame which} {
    global current
    global ds9

    # no frame
    if {$frame == {}} {
	SetWCSCoordMenu $which disabled
	return
    }

    # unloaded frame
    if {![$frame has fits]} {
	SetWCSCoordMenu $which normal
	return
    }

    # loaded frame
    if {[$frame has wcs WCS]} {
	$which entryconfig [msgcat::mc {WCS}] -state normal
    } else {
	$which entryconfig [msgcat::mc {WCS}] -state disabled
    }
    $which entryconfig [msgcat::mc {Multiple WCS}] -state normal
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	if {[$frame has wcs WCS$l]} {
	    $which.wcs entryconfig "[msgcat::mc {WCS}] $l" -state normal
	} else {
	    $which.wcs entryconfig "[msgcat::mc {WCS}] $l" -state disabled
	}
    }

    if {[$frame has wcs equatorial WCS]} {
	SetSkyFrameMenu $which normal
    } else {
	SetSkyFrameMenu $which disable
    }
}

proc SetWCSCoordMenu {which value} {
    global ds9

    $which entryconfig [msgcat::mc {WCS}] -state $value
    $which entryconfig [msgcat::mc {Multiple WCS}] -state $value

    $which entryconfig "[msgcat::mc {Equatorial}] B1950" -state $value
    $which entryconfig "[msgcat::mc {Equatorial}] J2000" -state $value
    $which entryconfig [msgcat::mc {ICRS}] -state $value
    $which entryconfig [msgcat::mc {Galactic}] -state $value
    $which entryconfig [msgcat::mc {Ecliptic}] -state $value

    $which entryconfig [msgcat::mc {Degrees}] -state $value
    $which entryconfig {Sexagesimal} -state $value

    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$which.wcs entryconfig "[msgcat::mc {WCS}] $l" -state $value
    }
}

