#  Copyright (C) 1999-2007
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc ZoomMenu {} {
    global ds9

    menu $ds9(mb).zoom
    $ds9(mb).zoom add command -label [msgcat::mc {Center Image}] \
	-command CenterCurrentFrame
    $ds9(mb).zoom add separator
    $ds9(mb).zoom add checkbutton -label [msgcat::mc {Align}] \
	-variable wcs(align) -command AlignWCSFrame
    $ds9(mb).zoom add cascade -label [msgcat::mc {Align WCS}] \
	-menu $ds9(mb).zoom.align
    $ds9(mb).zoom add separator
    $ds9(mb).zoom add command -label [msgcat::mc {Zoom In}] \
	-command {Zoom 2 2}
    $ds9(mb).zoom add command -label [msgcat::mc {Zoom Out}] \
	-command {Zoom .5 .5}
    $ds9(mb).zoom add separator
    $ds9(mb).zoom add command -label [msgcat::mc {Zoom to Fit Frame}] \
	-command ZoomToFit
    $ds9(mb).zoom add separator
    $ds9(mb).zoom add radiobutton -label "[msgcat::mc {Zoom}] 1/32" \
	-variable current(zoom) -value { 0.03125 0.03125 } -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label "[msgcat::mc {Zoom}] 1/16" \
	-variable current(zoom) -value { 0.0625 0.0625 }  -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label "[msgcat::mc {Zoom}] 1/8" \
	-variable current(zoom) -value { 0.125 0.125 }  -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label "[msgcat::mc {Zoom}] 1/4" \
	-variable current(zoom) -value { 0.25 0.25 } -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label "[msgcat::mc {Zoom}] 1/2" \
	-variable current(zoom) -value { 0.5 0.5 } -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label "[msgcat::mc {Zoom}] 1" \
	-variable current(zoom) -value { 1 1 } -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label "[msgcat::mc {Zoom}] 2" \
	-variable current(zoom) -value { 2 2 } -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label "[msgcat::mc {Zoom}] 4" \
	-variable current(zoom) -value { 4 4 } -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label "[msgcat::mc {Zoom}] 8" \
	-variable current(zoom) -value { 8 8 } -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label "[msgcat::mc {Zoom}] 16" \
	-variable current(zoom) -value { 16 16 } -command ChangeZoom
    $ds9(mb).zoom add radiobutton -label "[msgcat::mc {Zoom}] 32" \
	-variable current(zoom) -value { 32 32 } -command ChangeZoom
    $ds9(mb).zoom add separator
    $ds9(mb).zoom add radiobutton -label [msgcat::mc {None}] \
	-variable current(orient) -value none -command ChangeOrient
    $ds9(mb).zoom add radiobutton -label "[msgcat::mc {Invert}] X" \
	-variable current(orient) -value x -command ChangeOrient
    $ds9(mb).zoom add radiobutton -label "[msgcat::mc {Invert}] Y" \
	-variable current(orient) -value y -command ChangeOrient
    $ds9(mb).zoom add radiobutton -label "[msgcat::mc {Invert}] XY" \
	-variable current(orient) -value xy -command ChangeOrient
    $ds9(mb).zoom add separator
    $ds9(mb).zoom add radiobutton -label "0 [msgcat::mc {Degrees}]" \
	-variable current(rotate) -value 0 -command ChangeRotate
    $ds9(mb).zoom add radiobutton -label "90 [msgcat::mc {Degrees}]" \
	-variable current(rotate) -value 90 -command ChangeRotate
    $ds9(mb).zoom add radiobutton -label "180 [msgcat::mc {Degrees}]" \
	-variable current(rotate) -value 180 -command ChangeRotate
    $ds9(mb).zoom add radiobutton -label "270 [msgcat::mc {Degrees}]" \
	-variable current(rotate) -value 270 -command ChangeRotate
    $ds9(mb).zoom add separator
    $ds9(mb).zoom add command \
	-label "[msgcat::mc {Pan Zoom Rotate Parameters}]..." \
	-command PanZoomDialog

    menu $ds9(mb).zoom.align
    $ds9(mb).zoom.align add radiobutton -label [msgcat::mc {WCS}] \
	-variable wcs(align,system) -value wcs -command AlignWCSFrame
    $ds9(mb).zoom.align add cascade -label [msgcat::mc {Multiple WCS}] \
	-menu $ds9(mb).zoom.align.wcs
    $ds9(mb).zoom.align add separator
    $ds9(mb).zoom.align add radiobutton \
	-label "[msgcat::mc {Equatorial}] B1950" \
	-variable wcs(align,sky) -value fk4 -command AlignWCSFrame
    $ds9(mb).zoom.align add radiobutton \
	-label "[msgcat::mc {Equatorial}] J2000" \
	-variable wcs(align,sky) -value fk5 -command AlignWCSFrame
    $ds9(mb).zoom.align add radiobutton -label [msgcat::mc {ICRS}] \
	-variable wcs(align,sky) -value icrs -command AlignWCSFrame
    $ds9(mb).zoom.align add radiobutton -label [msgcat::mc {Galactic}] \
	-variable wcs(align,sky) -value galactic -command AlignWCSFrame
    $ds9(mb).zoom.align add radiobutton -label [msgcat::mc {Ecliptic}] \
	-variable wcs(align,sky) -value ecliptic -command AlignWCSFrame

    menu $ds9(mb).zoom.align.wcs
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$ds9(mb).zoom.align.wcs add radiobutton \
	    -label "[msgcat::mc {WCS}] $l" \
	    -variable wcs(align,system) -value "wcs$l" -command AlignWCSFrame
    }

    ZoomPrefsMenu
}

proc ZoomPrefsMenu {} {
    global ds9
    global prefs

    menu $ds9(mb).prefs.gui.zoom
    $ds9(mb).prefs.gui.zoom add checkbutton -label [msgcat::mc {Align}] \
	-variable prefs(wcs,align) -command SavePrefs
    $ds9(mb).prefs.gui.zoom add cascade -label [msgcat::mc {Align WCS}] \
	-menu $ds9(mb).prefs.gui.zoom.align
    $ds9(mb).prefs.gui.zoom add separator
    $ds9(mb).prefs.gui.zoom add radiobutton -label "[msgcat::mc {Zoom}] 1/32" \
	-variable prefs(zoom) -value { 0.03125 0.03125 } -command SavePrefs
    $ds9(mb).prefs.gui.zoom add radiobutton -label "[msgcat::mc {Zoom}] 1/16" \
	-variable prefs(zoom) -value { 0.0625 0.0625 } -command SavePrefs
    $ds9(mb).prefs.gui.zoom add radiobutton -label "[msgcat::mc {Zoom}] 1/8" \
	-variable prefs(zoom) -value { 0.125 0.125 } -command SavePrefs
    $ds9(mb).prefs.gui.zoom add radiobutton -label "[msgcat::mc {Zoom}] 1/4" \
	-variable prefs(zoom) -value { 0.25 0.25 } -command SavePrefs
    $ds9(mb).prefs.gui.zoom add radiobutton -label "[msgcat::mc {Zoom}] 1/2" \
	-variable prefs(zoom) -value { 0.5 0.5 } -command SavePrefs
    $ds9(mb).prefs.gui.zoom add radiobutton -label "[msgcat::mc {Zoom}] 1" \
	-variable prefs(zoom) -value { 1 1 } -command SavePrefs
    $ds9(mb).prefs.gui.zoom add radiobutton -label "[msgcat::mc {Zoom}] 2" \
	-variable prefs(zoom) -value { 2 2 } -command SavePrefs
    $ds9(mb).prefs.gui.zoom add radiobutton -label "[msgcat::mc {Zoom}] 4" \
	-variable prefs(zoom) -value { 4 4 } -command SavePrefs
    $ds9(mb).prefs.gui.zoom add radiobutton -label "[msgcat::mc {Zoom}] 8" \
	-variable prefs(zoom) -value { 8 8 } -command SavePrefs
    $ds9(mb).prefs.gui.zoom add radiobutton -label "[msgcat::mc {Zoom}] 16" \
	-variable prefs(zoom) -value { 16 16 } -command SavePrefs
    $ds9(mb).prefs.gui.zoom add radiobutton -label "[msgcat::mc {Zoom}] 32" \
	-variable prefs(zoom) -value { 32 32 } -command SavePrefs
    $ds9(mb).prefs.gui.zoom add separator
    $ds9(mb).prefs.gui.zoom add radiobutton -label [msgcat::mc {None}] \
	-variable prefs(orient) -value none -command SavePrefs
    $ds9(mb).prefs.gui.zoom add radiobutton -label "[msgcat::mc {Invert}] X" \
	-variable prefs(orient) -value x -command SavePrefs
    $ds9(mb).prefs.gui.zoom add radiobutton -label "[msgcat::mc {Invert}] Y" \
	-variable prefs(orient) -value y -command SavePrefs
    $ds9(mb).prefs.gui.zoom add radiobutton -label "[msgcat::mc {Invert}] XY" \
	-variable prefs(orient) -value xy -command SavePrefs
    $ds9(mb).prefs.gui.zoom add separator
    $ds9(mb).prefs.gui.zoom add radiobutton \
	-label "0 [msgcat::mc {Degrees}]" \
	-variable prefs(rotate) -value 0  -command SavePrefs
    $ds9(mb).prefs.gui.zoom add radiobutton \
	-label "90 [msgcat::mc {Degrees}]"\
	-variable prefs(rotate) -value 90 -command SavePrefs
    $ds9(mb).prefs.gui.zoom add radiobutton \
	-label "180 [msgcat::mc {Degrees}]"\
	-variable prefs(rotate) -value 180 -command SavePrefs
    $ds9(mb).prefs.gui.zoom add radiobutton \
	-label "270 [msgcat::mc {Degrees}]" \
	-variable prefs(rotate) -value 270 -command SavePrefs

    menu $ds9(mb).prefs.gui.zoom.align
    $ds9(mb).prefs.gui.zoom.align add radiobutton -label [msgcat::mc {WCS}] \
	-variable prefs(wcs,align,system) -value wcs -command SavePrefs
    $ds9(mb).prefs.gui.zoom.align add cascade \
	-label [msgcat::mc {Multiple WCS}] \
	-menu $ds9(mb).prefs.gui.zoom.align.wcs
    $ds9(mb).prefs.gui.zoom.align add separator
    $ds9(mb).prefs.gui.zoom.align add radiobutton \
	-label "[msgcat::mc {Equatorial}] B1950" \
	-variable prefs(wcs,align,sky) -value fk4 -command SavePrefs
    $ds9(mb).prefs.gui.zoom.align add radiobutton \
	-label "[msgcat::mc {Equatorial}] J2000" \
	-variable prefs(wcs,align,sky) -value fk5 -command SavePrefs
    $ds9(mb).prefs.gui.zoom.align add radiobutton \
	-label [msgcat::mc {ICRS}] \
	-variable prefs(wcs,align,sky) -value icrs -command SavePrefs
    $ds9(mb).prefs.gui.zoom.align add radiobutton \
	-label [msgcat::mc {Galactic}] \
	-variable prefs(wcs,align,sky) -value galactic -command SavePrefs
    $ds9(mb).prefs.gui.zoom.align add radiobutton \
	-label [msgcat::mc {Ecliptic}] \
	-variable prefs(wcs,align,sky) -value ecliptic -command SavePrefs

    menu $ds9(mb).prefs.gui.zoom.align.wcs
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	$ds9(mb).prefs.gui.zoom.align.wcs add radiobutton \
	    -label "[msgcat::mc {WCS}] $l" \
	    -variable prefs(wcs,align,system) -value "wcs$l" -command SavePrefs
    }
}

proc ZoomButtons {} {
    global ds9
    global wcs

    frame $ds9(buttons).zoom
    ButtonButton $ds9(buttons).zoom.center \
	[string tolower [msgcat::mc {Center}]] CenterCurrentFrame
    CheckButton $ds9(buttons).zoom.align \
	[string tolower [msgcat::mc {Align}]] wcs(align) AlignWCSFrame
    ButtonButton $ds9(buttons).zoom.in \
	[string tolower [msgcat::mc {In}]] {Zoom 2 2}
    ButtonButton $ds9(buttons).zoom.out \
	[string tolower [msgcat::mc {Out}]] {Zoom .5 .5}
    ButtonButton $ds9(buttons).zoom.fit \
	[string tolower [msgcat::mc {To Fit}]] ZoomToFit
    RadioButton $ds9(buttons).zoom.none \
	[string tolower [msgcat::mc {None}]] current(orient) none ChangeOrient
    RadioButton $ds9(buttons).zoom.x {x} current(orient) x ChangeOrient
    RadioButton $ds9(buttons).zoom.y {y} current(orient) y ChangeOrient
    RadioButton $ds9(buttons).zoom.xy {xy} current(orient) xy ChangeOrient
    RadioButton $ds9(buttons).zoom.r0 \
	"0 [string tolower [msgcat::mc {Degrees}]]" \
	current(rotate) 0 ChangeRotate
    RadioButton $ds9(buttons).zoom.r90 \
	"90 [string tolower [msgcat::mc {Degrees}]]" \
	current(rotate) 90 ChangeRotate
    RadioButton $ds9(buttons).zoom.r180 \
	"180 [string tolower [msgcat::mc {Degrees}]]" \
	current(rotate) 180 ChangeRotate
    RadioButton $ds9(buttons).zoom.r270 \
	"270 [string tolower [msgcat::mc {Degrees}]]" \
	current(rotate) 270 ChangeRotate
}

proc UpdateZoomMenu {} {
    global ds9
    global current
    global wcs
    global panzoom
    
    global debug
    if {$debug(tcl,update)} {
	puts "UpdateZoomMenu"
    }

    UpdateAlignWCSMenu $ds9(mb).zoom

    if {$current(frame) != {}} {
	$ds9(mb) entryconfig [msgcat::mc {Zoom}] -state normal
	$ds9(buttons).major.zoom configure -state normal

	set panzoom(preserve) [$current(frame) get pan preserve]

	if {[$current(frame) has fits]} {
	    $ds9(mb).zoom entryconfig [msgcat::mc {Zoom to Fit Frame}] \
		-state normal
	} else {
	    $ds9(mb).zoom entryconfig [msgcat::mc {Zoom to Fit Frame}] \
		-state disabled
	}

	set current(zoom) [$current(frame) get zoom]
	set current(rotate) [$current(frame) get rotate]
	set current(orient) [$current(frame) get orient]
	set align [$current(frame) get wcs align]

	set wcs(align) [lindex $align 0]
	set wcs(align,system) [lindex $align 1]
	set wcs(align,sky) [lindex $align 2]
    } else {
	$ds9(mb) entryconfig [msgcat::mc {Zoom}] -state disabled
	$ds9(buttons).major.zoom configure -state disabled

	set panzoom(preserve) 0

	set current(zoom) { 1 1 }
	set current(rotate) 0
	set current(orient) none

	set wcs(align) 0
	set wcs(align,system) wcs
	set wcs(align,sky) fk5
    }
}

proc UpdateAlignWCSMenu {which} {
    global current
    global wcs

    # no frame
    if {$current(frame) == {}} {
	$which entryconfig [msgcat::mc {Align}] -state disabled
	$which entryconfig [msgcat::mc {Align WCS}] -state disabled
	return
    }

    # unloaded frame
    if {![$current(frame) has fits]} {
	$which entryconfig [msgcat::mc {Align}]  -state normal
	$which entryconfig [msgcat::mc {Align WCS}] -state normal

	$which.align entryconfig [msgcat::mc {WCS}] -state normal
	$which.align entryconfig [msgcat::mc {Multiple WCS}] -state normal

	$which.align entryconfig "[msgcat::mc {Equatorial}] B1950" \
	    -state normal
	$which.align entryconfig "[msgcat::mc {Equatorial}] J2000" \
	    -state normal
	$which.align entryconfig [msgcat::mc {ICRS}] -state normal
	$which.align entryconfig [msgcat::mc {Galactic}] -state normal
	$which.align entryconfig [msgcat::mc {Ecliptic}] -state normal

	foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	    $which.align.wcs entryconfig "[msgcat::mc {WCS}] $l" \
		-state normal
	}
	return
    }

    # loaded frame
    $which entryconfig [msgcat::mc {Align}] -state normal
    $which entryconfig [msgcat::mc {Align WCS}] -state normal

    if {[$current(frame) has wcs WCS]} {
	$which.align entryconfig [msgcat::mc {WCS}] -state normal
    } else {
	$which.align entryconfig [msgcat::mc {WCS}] -state disabled
    }
    $which.align entryconfig [msgcat::mc {Multiple WCS}] -state normal
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	if {[$current(frame) has wcs WCS$l]} {
	    $which.align.wcs entryconfig "[msgcat::mc {WCS}] $l" \
		-state normal
	} else {
	    $which.align.wcs entryconfig "[msgcat::mc {WCS}] $l" \
		-state disabled
	}
    }

    SetSkyFrameMenu2 $which.align disabled

    if {$current(frame) != {}} {
	if {[$current(frame) has fits]} {
	    switch -- $wcs(align,system) {
		wcs {}
		default {
		    if {![$current(frame) has wcs $wcs(align,system)]} {
			    set wcs(align,system) wcs
		    }
		}
	    }

	    if [$current(frame) has wcs equatorial $wcs(align,system)] {
		SetSkyFrameMenu2 $which.align normal
	    }
	}
    }
}
