# usage: mergedict <##>

set mm [lindex $argv 0]
set enc [lindex $argv 1]
set fn "msgs/${mm}.msg"

# read in msg file
if {[catch {open $fn r} id]} {
    puts "Error: can't open $fn for reading"
    return
}
fconfigure $id -encoding $enc

set msg {}
while {[gets $id line] >= 0} {
    lappend msg $line
}
set msg [lsort -unique $msg]
catch {close $id}

# read lst
set lst {}
while {[gets stdin line] >= 0} {
    set exp {.*msgcat::mc {([^\}]*)}}
    if [regexp $exp $line foo aa] {
	lappend lst "::msgcat::mcset $mm {$aa} "
    }
}
set lst [lsort -unique $lst]

# now merge
if {[catch {open $fn w} id]} {
    puts "Error: can't open $fn for writing"
    return
}
fconfigure $id -encoding $enc

foreach ll $lst {
    set ii [lsearch $msg "$ll*"]
    if {$ii != -1} {
	puts $id [lindex $msg $ii]
    } else {
	puts $id $ll
    }
}
catch {close $id}
